import request from '@/api/main/request.js'

//获取gdb下的矢量图层
export function getlayers(parameter) {
    return request({
        url: '/vector/gdb/getlayers',
        method: 'post',
        data: parameter,
        headers: {
            'Content-Type': 'application/json'
        }
    })
}
//删除矢量图层后台缓存
export function remove(parameter) {
    return request({
        url: '/vector/gdb/remove',
        method: 'post',
        data: parameter,
        headers: {
            'Content-Type': 'application/json'
        }
    })
}
//获取mdb下的表名
export function gettables(parameter) {
    return request({
        url: '/vector/mdb/gettables',
        method: 'post',
        data: parameter,
        headers: {
            'Content-Type': 'application/json'
        }
    })
}
//获取mdb下的指定表
export function gettable(parameter) {
    return request({
        url: '/vector/mdb/gettable',
        method: 'post',
        data: parameter,
        headers: {
            'Content-Type': 'application/json'
        }
    })
}
// 矢量图层空间查询、属性查询（SPATIALFILTER参数参考geojson标准，ATTRIBUTEFILTER参数参考sql语言规范）
export function filter(parameter) {
    return request({
        url: '/vector/gdb/filter',
        method: 'post',
        data: parameter,
        headers: {
            'Content-Type': 'application/json'
        }
    })
}
// 获取矢量图层字段集合
export function getFields(parameter) {
    return request({
        url: '/vector/gdb/getFields',
        method: 'post',
        data: parameter,
        headers: {
            'Content-Type': 'application/json'
        }
    })
}
// 获取矢量图层唯一值
export function getUniqueValue(parameter) {
    return request({
        url: '/vector/gdb/getUniqueValue',
        method: 'post',
        data: parameter,
        headers: {
            'Content-Type': 'application/json'
        }
    })
}
// esrijson转shp
export function jsonToShp(parameter) {
    return request({
        url: '/analyse/tool/jsonToShp',
        method: 'post',
        data: parameter,
        headers: {
            'Content-Type': 'application/json'
        }
    })
}