/**
 * @Description: 
 * @version: 
 * @Author: 北京四维空间数码科技有限公司-研发部
 * @Date: 2023-01-11 13:52:38
 * @LastEditors: 北京四维空间数码科技有限公司-研发部
 * @LastEditTime: 2023-03-03 14:12:11
 */
import axios from 'axios';
import { ElMessage } from 'element-plus'
import NProgress from 'nprogress'

const service = axios.create({
    baseURL: import.meta.env.VITE_GDAL_API,
    withCredentials: true,
    timeout: 100000
})

service.interceptors.request.use((config) => {
    NProgress.start()
    return config
}, (error) => {
    NProgress.done()
    console.log(error);
    ElMessage.error(error)
    return Promise.reject(error);
})

service.interceptors.response.use((response) => {
    NProgress.done()
    const res = response.data

    if (res.code !== '200' && res.code !== 200) {
        console.log(res.message || res.msg || 'Error');
        ElMessage({
            message: res.message || res.msg || 'Error',
            type: 'warning',
        })
        return Promise.reject(new Error(res.message || res.msg || 'Error'))
    } else {
        return res
    }
}, (error) => {
    NProgress.done()
    console.log('err' + error)
    ElMessage.error('请求失败，请稍后再试')
    return Promise.reject(error)
})

export default service;