/*
 * @Description: 元数据
 * @Author: 北京四维空间数码科技有限公司-研发部
 * @Date: 2023-07-05 15:03:10
 * @LastEditors: 北京四维空间数码科技有限公司-研发部
 * @LastEditTime: 2023-07-11 15:39:03
 */

import request from './request'

let isDev = import.meta.env.MODE == "development"

// 获取初始信息
export function getinfo(data) {
    let url = '/metadata/getinfo'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'get',
        params: data,
    })
}

// 自动获取元数据
export function gather(data) {
    let url = '/metadata/gather'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'get',
        params: data,
    })
}

// 元数据保存
export function save(data) {
    let url = '/metadata/save'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'post',
        data: data,
    })
}

// ========

// 矢量元数据导入
export function impMeta(data) {
    let url = '/metadata/impMeta'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'post',
        data: data,
    })
}

// 获取xml文件
export function getXmlDoc(data) {
    let url = '/metadata/getXmlDoc'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'post',
        data: data,
    })
}

// 获取元数据资源节点目录
export function getXmlDir(data) {
    let url = '/metadata/getXmlDir'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'post',
        data: data,
    })
}

// 获取元数据资源节点目录
export function saveXmlValue(data) {
    let url = '/metadata/saveXmlValue'
    if (!isDev) {
        url = '/dbms' + url
    }
    return request({
        url,
        method: 'post',
        data: data,
    })
}

// =======
// 获取质检列表
export function getList(data) {
    let url = '/datacheck/list'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'get',
        params: data,
    })
}

// 获取质检方案
export function getscheme(data) {
    let url = '/datacheck/getscheme'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'get',
        params: data,
    })
}

// 新建质检
export function startcheck(data) {
    let url = '/datacheck/startcheck'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'post',
        data,
        headers: { 'Content-Type': 'application/json' },
    })
}

// 删除
export function datacheckdelete(params) {
    let url = '/datacheck/delete'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'get',
        params,
    })
}

// ===========
// 管理列表
export function datamanagelist(params) {
    let url = '/datamanage/list'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'get',
        params,
    })
}

// 加入管理
export function datamanageadd(params) {
    let url = '/datamanage/add'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'get',
        params,
    })
}
// 移除管理
export function datamanagedelete(params) {
    let url = '/datamanage/delete'
    if (!isDev) {

        url = '/dbms' + url
    }
    return request({
        url,
        method: 'get',
        params,
    })
}

