/**
 * @Description:
 * @version:
 * @Author: 北京四维空间数码科技有限公司-研发部
 * @Date: 2022-12-02 17:26:06
 * @LastEditors: 北京四维空间数码科技有限公司-研发部
 * @LastEditTime: 2023-02-01 13:56:18
 */
import { createApp } from 'vue'
import ElementPlus from 'element-plus'
import zhCn from 'element-plus/dist/locale/zh-cn.mjs'
import 'element-plus/dist/index.css'
import '@/style.css'
import '@/assets/styles/index.scss' // global css
import router from './router'
import './permission'
import { createPinia } from 'pinia'

import NProgress from 'nprogress'
NProgress.configure({ showSpinner: false })
import 'nprogress/nprogress.css'
import * as ElementPlusIconsVue from '@element-plus/icons-vue'
// icon图标
import "@/assets/icon/iconfont.css"

import App from './App.vue'
// 注册指令
import plugins from "./plugins"; // plugins
import hljs from 'highlight.js'
import 'highlight.js/styles/atom-one-dark.css'

const app = createApp(App)
for (const [key, component] of Object.entries(ElementPlusIconsVue)) {
  app.component(key, component)
}
app.use(plugins);
app.use(router)
app.use(createPinia())
app.use(ElementPlus, {
  locale: zhCn,
})
app.directive('highlight',function(el){  //自定义指令
  let blocks = el.querySelectorAll('pre code');
  blocks.forEach((block)=>{
      hljs.highlightBlock(block)
  })
})
app.mount('#app')
