/**
 * @Description:
 * @version:
 * @Author: 北京四维空间数码科技有限公司-研发部
 * @Date: 2023-04-07 15:06:28
 * @LastEditors: 北京四维空间数码科技有限公司-研发部
 * @LastEditTime: 2023-05-09 09:26:50
 */
import router from '@/router/index';
// import { project_name } from '/public/config/config.json';
import { getToken } from '@/utils/auth'
// import { Message } from 'element-ui'
// import { mainStore } from "@/store/index";
// import { getInfo } from "@/api/user/login";
import { toRefs } from 'vue'
import { ElMessageBox } from 'element-plus'
import { ElMessage } from 'element-plus'
import { ElNotification } from 'element-plus'


router.beforeEach((to, from, next) => {
  next()
  return

  const customerToken = getToken('Customer-Token')
  const adminToken = getToken('Admin-Token')
  // document.title = to.meta.title || project_name
  const permission = to.meta.permission

  let store = mainStore()
  store.$patch({
    token: customerToken
  });

  if (to.path === '/login') {
    if (customerToken) {
      // Message('您已经登录了')
      let url
      try {
        url = this.$route.query.redirect || '/'
      } catch (error) {
        url = '/'
      }
      next(url)
      return
    }
  }

  if (permission === 0) {
    next()
  } else if (permission === 1) {
    // 顾客登录
    if (customerToken) {
      next()
    } else {
      // ElMessageBox.$message('请登录后继续')
      // ElMessage.success({
      //   message: '请登录后继续'
      // })

      ElMessageBox.alert('请先登录后再使用该功能...', '提示', {
        confirmButtonText: '去登录',
        callback: () => {
          next(`/login?redirect=${encodeURIComponent(encodeURIComponent(to.fullPath))}`)
        },
      })

    }
  } else if (permission === 2) {
    // 管理员
    if (adminToken) {
      next()
    } else {
      next(`/admin/login?redirect=${encodeURIComponent(to.fullPath)}`)
    }
  } else {
    next();
  }

  if (customerToken && !store.userInfo) {
    getInfo().then((res) => {
      store.$patch({
        userInfo: JSON.stringify(res.data)
      });
      // this.$router.push({ path: this.redirect || "/" }).catch(() => {});

      // window.socket = io('http://192.168.100.21:7001/', {
      // window.socket = io('http://39.98.45.204:7001/', {
      // window.socket = io('http://socket.bjsiwei.net.cn/', {
      window.socket = io(import.meta.env.VITE_BASE_SOCKET, {
        query: {},
        transports: ['websocket', 'polling'],
      })

      socket.on("connect", () => {
        // console.log("connected!", socket.id);
        socket.emit("setName", res.data);
      });

      socket.on("message", (message) => {
        console.log(message);
      })

      socket.on("changePrice", (message) => {
        ElNotification({
          title: '系统通知',
          dangerouslyUseHTMLString: true,
          message: `管理员已修改订单价格为:${message.account}元
          <br/> <a href="/#/orderDetail?id=${message.id}" target="_blank" style="color: blue;">查看订单</a>`,
          type: 'success',
          duration: 0,
        })

        speech.speak({
          text: `您有新的消息, 管理员已修改订单价格为:${message.account}元`
        }).then(() => {
          console.log("播报完成...")
        })
      });

      socket.on("changeStatus", (message) => {

        ElNotification({
          title: '系统通知',
          dangerouslyUseHTMLString: true,
          message: `管理员已修改订单状态为:${message.status}
          <br/> <a href="/#/orderDetail?id=${message.id}" target="_blank" style="color: blue;">查看订单</a>`,
          type: 'success',
          duration: 0,
        })

        speech.speak({
          text: `您有新的消息, 管理员已修改订单状态为:${message.status}`
        }).then(() => {
          console.log("播报完成...")
        })
      });


    }).catch(() => {
      // this.loading = false;
      // if (this.captchaEnabled) {
      //     this.getCode();
      // }

      // Notification.requestPermission(function (status) {
      //   if (status === "granted") {
      //        var n = new Notification("Hi!");
      //    } else {
      //         alert("Hi!");
      //    }
      // });

      // if(window.Notification && Notification.permission !== "denied") {
      //   Notification.requestPermission(function(status) {
      //       var n = new Notification('通知标题', { body: '这里是通知内容！' });
      //   });
      // }

    });

  }
})

router.afterEach((to, from) => { })
