/**
 * @Description:
 * @version:
 * @Author: 北京四维空间数码科技有限公司-研发部
 * @Date: 2022-12-09 12:04:31
 * @LastEditors: 北京四维空间数码科技有限公司-研发部
 * @LastEditTime: 2023-05-08 17:34:17
 */
import { createRouter, createWebHashHistory } from 'vue-router'
import Layout from '@/views/layout/index.vue';

export const constantRoutes = [

    {
        path: '/',
        name: 'Layout',
        component: Layout,

        children: [
            {
                path: '',
                name: 'index',
                component: () => import('@/views/dataPreprocessing/index.vue'),
                meta: {
                    title: '数据预处理',
                }
            },

            {
                path: 'dataManagement',
                name: 'dataManagement',
                component: () => import('@/views/dataManagement/index.vue'),
                meta: {
                    title: '数据管理',
                }
            },

            {
                path: 'dataStatistic',
                name: 'dataStatistic',
                component: () => import('@/views/dataStatistic/index.vue'),
                meta: {
                    title: '数据统计',
                }
            },
            
            {
                path: 'dataStatistics',
                name: 'dataStatistics',
                component: () => import('@/views/dataStatistics/index.vue'),
                meta: {
                    title: '数据统计',
                }
            },

            {
                path: 'dataMaintenance',
                name: 'dataMaintenance',
                redirect: "/dataUpdates",
                component: () => import('@/views/dataMaintenance/index.vue'),
                meta: {
                    title: '数据维护',
                },
                children: [
                    {
                        path: '/dataUpdates',
                        name: 'dataUpdates',
                        component: () => import('@/views/dataMaintenance/componets/dataUpdates.vue'),
                        meta: { 
                            title: '数据更新' 
                        }
                    },
                    {
                        path: '/mvdataManagement',
                        name: 'mvdataManagement',
                        component: () => import('@/views/dataMaintenance/componets/mvdataManagement.vue'),
                        meta: { 
                            title: '多版本数据管理' 
                        }
                    },
                    {
                        path: '/dataBackup',
                        name: 'dataBackup',
                        meta: {
                            title: '数据备份' 
                        },
                        children: [
                            {
                                path: '/dataBackup/policyManagement',
                                name: 'policyManagement',
                                component: () => import('@/views/dataMaintenance/componets/dataBackup/policyManagement.vue'),
                                meta: { 
                                    title: '备份策略管理' 
                                }
                            },
                            {
                                path: '/dataBackup/taskManagement',
                                name: 'taskManagement',
                                component: () => import('@/views/dataMaintenance/componets/dataBackup/taskManagement.vue'),
                                meta: { 
                                    title: '备份任务管理' 
                                }
                            },
                            {
                                path: '/dataBackup/resumeManagement',
                                name: 'resumeManagement',
                                component: () => import('@/views/dataMaintenance/componets/dataBackup/resumeManagement.vue'),
                                meta: { 
                                    title: '数据恢复管理' 
                                }
                            },
                        ]
                    },
                ]
            },

            {
                path: 'logManagement',
                name: 'logManagement',
                component: () => import('@/views/logManagement/index.vue'),
                meta: {
                    title: '日志管理',
                },
            },

            {
                path: 'systemSettings',
                name: 'systemSettings',
                component: () => import('@/views/systemSettings/index.vue'),
                meta: {
                    title: '系统设置',
                }
            },
        ]
    },
    {
        path: '/404',
        component: () => import('@/views/error/404.vue'),
        hidden: true
    },
    {
        path: '/401',
        component: () => import('@/views/error/401.vue'),
        hidden: true
    },
    {
        path: '/:pathMatch(.*)*',
        name: '404',
        component: () => import('@/views/error/404.vue'),
    },
]

const router = createRouter({
    history: createWebHashHistory(),
    scrollBehavior: () => ({ top: 0 }),
    routes: [
        ...constantRoutes,
    ]
})

router.beforeEach((to, from, next) => {
    next()
})

export default router
