﻿import proj4 from 'proj4'
// import { register } from 'ol/proj/proj4';
import { addCoordinateTransforms, transform, addProjection } from 'ol/proj'
// import * as proj from 'ol/proj'
import Projection from 'ol/proj/projection';

import axios from 'axios';
import prjConfig from '@/utils/Projection.json'
//ol添加投影坐标系
//addProjectionTransform([112.863, 42.417], "EPSG:4491", "EPSG:4526", false);
// var prjConfig = {}
export function addProjectionTransform(pointArr, inSR, outSR, isPointArr, isMultipleArr, callback) {
    inSR = inSR ? inSR : "EPSG:3857";
    outSR = outSR ? outSR : "EPSG:4326";
    var thisResult = {
        code: "200",
        msg: "转换成功",
        inSR: inSR,
        outSR: outSR,
        result: []
    }
    if (inSR == outSR) {
        thisResult.result = pointArr;
        callback(thisResult);
        return;
    }
    // var prjConfig = InitialParameter("../Json/Projection.json");
    // var prjConfig = {};
    // let path = process.env.NODE_ENV === "production" ? process.env.VUE_APP_URL : "/"
    // new Promise((resolve, reject) => {
    //     if (Object.keys(prjConfig).length === 0) {
    //         axios.get(path + 'utils/Projection.json').then(res=>{
    //             prjConfig = res.data
    //             resolve(prjConfig)
    //         }).catch(e=>{reject(e)})
    //     }else{
    //         resolve(prjConfig)
    //     }
    // }).then(res=>{
        
    // axios.get(path + 'json/Projection.json').then(res => {
        // prjConfig = res.data;
        var projections = prjConfig.projections;
        if (projections.hasOwnProperty(inSR) && projections.hasOwnProperty(outSR)) {
            var projectionIn, projectionOut;
            if (inSR != "EPSG:3857" && inSR != "EPSG:4326") {
                proj4.defs(inSR, projections[inSR].proj4);
                projectionIn = new Projection({
                    code: inSR
                });
                addProjection(projectionIn);
            }
            if (outSR != "EPSG:3857" && outSR != "EPSG:4326") {
                proj4.defs(outSR, projections[outSR].proj4);
                projectionOut = new Projection({
                    code: outSR
                });
                addProjection(projectionOut);
            }
            addCoordinateTransforms(inSR, outSR,
                function (coordinate) {
                    return proj4(inSR, outSR, coordinate);
                },
                function (coordinate) {
                    return proj4(outSR, inSR, coordinate);
                });
        }
        else {
            thisResult.code = "400";
            thisResult.msg = "无法识别的坐标系( ";
            if (!projections.hasOwnProperty(inSR)) {
                thisResult.result.push(inSR);
                thisResult.msg += inSR;

                if (!projections.hasOwnProperty(outSR)) {
                    thisResult.result.push(outSR);
                    thisResult.msg += (" " + outSR);
                }
            }
            else {
                if (!projections.hasOwnProperty(outSR)) {
                    thisResult.result.push(outSR);
                    thisResult.msg += outSR;
                }
            }
            thisResult.msg += " )";
            return thisResult;
        }
        if (isMultipleArr) {
            for (var i = 0; i < pointArr.length; i++) {
                thisResult.result.push([]);
                for (var j = 0; j < pointArr[i].length; j++) {
                    thisResult.result[i].push(transform(pointArr[i][j], inSR, outSR));
                }
            }
        }
        else {
            if (isPointArr) {
                for (var i = 0; i < pointArr.length; i++) {
                    thisResult.result.push(transform(pointArr[i], inSR, outSR));
                    //thisResult.result.push([]);
                    //for (var j = 0; j < pointArr[i].length; j++) {
                    //thisResult.result[i].push(transform(pointArr[i][j], inSR, outSR));
                    //}
                }
            }
            else {
                for (var i = 0; i < pointArr.length / 2; i++) {
                    thisResult.result.push(transform([pointArr[2 * i], pointArr[2 * i + 1]], inSR, outSR));
                }
            }
        }
        callback(thisResult);
    // })

    // }).catch(e=>{console.log(e);})
}

//Arcgis FlatCoordinates转rings数组
export function flatCoordinatesToRings(pointArr) {
    var thisResult = {
        start: null,
        result: [],
        resultNum: 0
    }
    var next = null;
    for (var i = 0; i < pointArr.length / 2; i++) {
        next = [pointArr[2 * i], pointArr[2 * i + 1]];
        if (thisResult.start == null) {
            thisResult.start = next;
            thisResult.result.push([]);
            thisResult.result[thisResult.resultNum].push(next);
            thisResult.resultNum++;
        }
        else if (next[0] == thisResult.start[0] && next[1] == thisResult.start[1]) {
            thisResult.start = null;
            thisResult.result[thisResult.resultNum - 1].push(next);
        }
        else {
            thisResult.result[thisResult.resultNum - 1].push(next);
        }
    }
    return thisResult.result;
}

//二维坐标转换########二维坐标转换########二维坐标转换########二维坐标转换
//地图坐标系坐标数组转经纬度数组
export function mapProjectionToWGS84_22(pointArr, prj) {
    prj = prj ? prj : map_Projection;
    var thisResult = new Array();
    for (var i = 0; i < pointArr.length / 2; i++) {
        thisResult.push(transform([pointArr[2 * i], pointArr[2 * i + 1]], prj, 'EPSG:4326'))
    }
    return thisResult;
}
//经纬度坐标转地图坐标
export function WGS84TomapProjection_22(pointArr, isPointArr) {
    var thisResult = new Array();
    if (isPointArr) {
        for (var i = 0; i < pointArr.length; i++) {
            thisResult.push(transform([pointArr[i][0], pointArr[i][1]], 'EPSG:4326', m_baseParameter['map_Projection']));
        }
    }
    else {
        for (var i = 0; i < pointArr.length / 2; i++) {
            thisResult.push(transform([pointArr[2 * i], pointArr[2 * i + 1]], 'EPSG:4326', m_baseParameter['map_Projection']));
        }
    }
    return thisResult;
}
//地图坐标转2000坐标
export function mapProjectionTo2000(pointArr) {
    var thisResult = new Array();
    if (map_Projection == "EPSG:3857") {
        for (var i = 0; i < pointArr.length / 2; i++) {
            thisResult.push([pointArr[2 * i], pointArr[2 * i + 1]]);
        }
    }
    else {
        for (var i = 0; i < pointArr.length / 2; i++) {
            thisResult.push(transform([pointArr[2 * i], pointArr[2 * i + 1]], map_Projection, 'EPSG:3857'));
        }
    }
    return thisResult;
}
//WGS84转2000坐标
export function WGS84To2000(pointArr, isPointArr) {
    var thisResult = new Array();
    if (isPointArr) {
        for (var i = 0; i < pointArr.length; i++) {
            thisResult.push(transform(pointArr[i], 'EPSG:4326', 'EPSG:3857'));
        }
    }
    else {
        for (var i = 0; i < pointArr.length / 2; i++) {
            thisResult.push(transform([pointArr[2 * i], pointArr[2 * i + 1]], 'EPSG:4326', 'EPSG:3857'));
        }
    }
    return thisResult;
}
//坐标转换
export function InSRToOutSR(pointArr, inSR, outSR, isPointArr) {
    var thisResult = new Array();
    if (isPointArr) {
        for (var i = 0; i < pointArr.length; i++) {
            thisResult.push(transform(pointArr[i], inSR, outSR));
        }
    }
    else {
        for (var i = 0; i < pointArr.length / 2; i++) {
            thisResult.push(transform([pointArr[2 * i], pointArr[2 * i + 1]], inSR, outSR));
        }
    }
    return thisResult;
}
//坐标格式转换
export function FlatCoordToCoordArr(flatCoord) {
    var result = new Array();
    for (var i = 0; i < flatCoord.length / 2; i++) {
        result.push([flatCoord[2 * i], flatCoord[2 * i + 1]]);
    }
    return result;
}
