import "ol/ol.css";
import TileLayer from "ol/layer/Tile";
import XYZ from "ol/source/XYZ";
import VectorLayer from "ol/layer/Vector";
import VectorSource from "ol/source/Vector";
import { Fill, Stroke, Circle, Style } from "ol/style";
export const baseLayer = {
    /*天地图影像*/
    tdtImg() {
        if (!BaseMap.tdtImg) return null;
        return new TileLayer({
            //天地图
            id: "tdtImg",
            name: "tdtImg",
            zIndex: -1000000000,
            visible: false,
            source: new XYZ({
                crossOrigin: "anonymous",
                url: BaseMap.tdtImg,
            }),
        });
    },
    /*天地图注记影像*/
    tdtImgAnn() {
        if (!BaseMap.tdtImgAnn) return null;
        return new TileLayer({
            //天地图
            id: "tdtImgAnn",
            zIndex: -999999999,
            name: "tdtImgAnn",
            visible: false,
            source: new XYZ({
                crossOrigin: "anonymous",
                url: BaseMap.tdtImgAnn,
            }),
        });
    },
    /*天地图矢量*/
    tdtVec() {
        if (!BaseMap.tdtVec) return null;
        return new TileLayer({
            //天地图
            id: "tdtVec",
            name: "tdtVec",
            zIndex: -1000000000,
            visible: true,
            source: new XYZ({
                crossOrigin: "anonymous",
                url: BaseMap.tdtVec,
            }),
        });
    },
    /*天地图注记矢量*/
    tdtVecAnn() {
        if (!BaseMap.tdtVecAnn) return null;
        return new TileLayer({
            //天地图
            id: "tdtVecAnn",
            zIndex: -999999999,
            name: "tdtVecAnn",
            visible: true,
            source: new XYZ({
                crossOrigin: "anonymous",
                url: BaseMap.tdtVecAnn,
            }),
        });
    },
    /*界线*/
    jxMap() {
        if (!BaseMap.jxMap) return null;
        return new TileLayer({
            //界线
            id: "jxMap",
            zIndex: -999999999,
            name: "jxMap",
            visible: true,
            source: new XYZ({
                crossOrigin: "anonymous",
                url: BaseMap.jxMap,
            }),
        });
    },
    cityLine() {
        return new VectorLayer({
            name: "cityLine",
            source: new VectorSource({
                features: [],
            }),
            style: new Style({
                stroke: new Stroke({
                    color: "#f02fff",
                    width: 2,
                    lineDash: [1, 2, 3, 4, 5, 6],
                }),
            }),
            zIndex: 9,
            visible: false,
        });
    },
};