/*
 * @Descripttion: 
 * @version: 
 * @Author: 牛夏蕊
 * @Date: 2022-07-29 11:20:03
 * @LastEditors: 郭亚伟 2241880990@qq.com
 * @LastEditTime: 2022-11-09 14:33:27
 */
// import { updateCesiumStore } from '@/utils/updateCesiumStore'
import * as Cesium from "cesium";
import { ArcgisService } from "@/utils/menu/map/provider/ArcgisService";
import { BaiduMapService } from "@/utils/menu/map/provider/BaiduMapService";
import { GaodeMapService } from "@/utils/menu/map/provider/GaodeMapService";
import { GeoJsonService } from "@/utils/menu/map/provider/GeoJsonService";
import { GltfService } from "@/utils/menu/map/provider/GltfService";
import { GoogleMapService } from "@/utils/menu/map/provider/GoogleMapService";
import { LGXServer } from "@/utils/menu/map/provider/LGXServer";
import { LoadJsonServer } from "@/utils/menu/map/provider/LoadJsonServer";
import { MVTVectorService } from "@/utils/menu/map/provider/MVTVectorService";
import { NMLWServer } from "@/utils/menu/map/provider/NMLWServer";
import { ObliqueService } from "@/utils/menu/map/provider/ObliqueService";
import { OpenJsonService } from "@/utils/menu/map/provider/OpenJsonService";
import { PoiService } from "@/utils/menu/map/provider/PoiService";
import { PrimitivePointService } from "@/utils/menu/map/provider/PrimivitePoints";
import { StreetMapService } from "@/utils/menu/map/provider/StreetMapService";
import { SWImageMapService } from "@/utils/menu/map/provider/SWImageService";
import { TemplateMapService } from "@/utils/menu/map/provider/TemplateMapService";
import { TerrainService } from "@/utils/menu/map/provider/TerrainService";
import { TiandituMapService } from "@/utils/menu/map/provider/TiandituMapService";
import { TileArcgisService } from "@/utils/menu/map/provider/TileArcgisService";
import { TileMongodbService } from "@/utils/menu/map/provider/TileMongodbService";
import { TileOSMService } from "@/utils/menu/map/provider/TileOSMService";
import { TileTiandituService } from "@/utils/menu/map/provider/TileTiandituService";
import { TileWMSService } from "@/utils/menu/map/provider/TileWMSService";
import { TileWMTSService } from "@/utils/menu/map/provider/TileWMTSService";
import { TileXYZService } from "@/utils/menu/map/provider/TileXYZService";
import { VectorService } from "@/utils/menu/map/provider/VectorService";
import { toRaw } from '@vue/reactivity'
import store from "@/store";

export const sw_servicetype = {
    sw_tile: "tile",
    sw_vector: "vector",
    sw_terrain: "terrain",
    sw_oblique: "oblique",
    sw_gltf: "gltf",
    sw_poi: "poi",
    sw_geojson: "geojson",
    sw_lgx: "lgx",
    sw_nmlw: "nmlw",
    sw_nmpoi: "nmpoi",
    sw_json: "json",
    sw_jsoninfo: "jsoninfo"
};
const sw_servertype = {
    sw_geoserver: "geoserver",
    sw_mongodb: "mongodb",
    sw_iis: "iis",
    sw_arcgis: "arcgis"
};
export const sw_source = {
    sw_xyz: "xyz",
    sw_arcgistile: "tilearcgisrest",
    sw_arcgis: "arcgis",
    sw_osm: "osm",
    sw_wms: "tilewms",
    sw_wmts: "wmts",
    sw_pbf: "pbftile",
    sw_mongodb: "mongodb",
    sw_baidu: "baidu",
    sw_gaode: "gaode",
    sw_google: "google",
    sw_tianditu: "tianditu",
    sw_template: "template",
    sw_gdaltile: "gdaltile",
    sw_streetmap: "streetmap",
    sw_tianditu_tile: "tianditutile"
};
// 配置项
const sw_source_type = {
    "0": sw_source.sw_arcgis,
    "1": sw_source.sw_streetmap,
    "2": sw_source.sw_tianditu_tile, // 天地图影像注记
    "4": sw_source.sw_template,
};
const sw_service_type = {
    "9": sw_servicetype.sw_terrain
}
// 获取proxy对象中的原始对象
// let cesium = toRaw(store.state.cesium);
//地图加载类
export function LayerHelper(layerInfo, isbasemap, viewer) {
    var LayerHelper = Object;
    LayerHelper.layerInfo = layerInfo;
    LayerHelper.isbasemap = isbasemap;
    LayerHelper.isLoad = false;
    LayerHelper.GetLayer = function () {
        var thisLayerInfo = this.layerInfo;
        var isLoad = this.isLoad;
        var id = thisLayerInfo.hasOwnProperty("GUID") ? thisLayerInfo.GUID : "";
        return window.treeList[id].imageryLayer;
    }
    LayerHelper.moveToUp = function () {
        viewer.imageryLayers.raise(window.treeList[this.layerInfo.GUID].imageryLayer);
    }
    LayerHelper.raiseToTop = function () {
        if (window.treeList[this.layerInfo.GUID].imageryLayer) {
            viewer.imageryLayers.raiseToTop(window.treeList[this.layerInfo.GUID].imageryLayer);
        }
    }
    LayerHelper.moveToDown = function () {
        viewer.imageryLayers.lower(window.treeList[this.layerInfo.GUID].imageryLayer);
    }
    LayerHelper.lowerToBottom = function () {
        if (window.treeList[this.layerInfo.GUID].imageryLayer) {
            viewer.imageryLayers.lowerToBottom(window.treeList[this.layerInfo.GUID].imageryLayer);
        }
    }
    LayerHelper.addLayer = function (visible) {
        // store.commit('showLoading')
        // var loading = ElLoading.service({
        //     // lock: true,
        //     // text: "加载中",
        //     // background: "rgba(0, 0, 0, 0.7)",
        //     background: "transparent",
        // });
        try {
            //#region 获取图层信息
            var thisLayerInfo = this.layerInfo;
            var isLoad = this.isLoad;
            var myLayer = null;
            var layerCount = 0;

            var id = thisLayerInfo.hasOwnProperty("GUID") ? thisLayerInfo.GUID : "";
            var layers = viewer.scene.imageryLayers;
            var primitives = viewer.scene.primitives;
            if (!window.treeList) {
                window.treeList = {}
            }
            if (!window.treeList[id]) {
                window.treeList[id] = thisLayerInfo
                window.treeList[id].imageryLayer = undefined
            }
            if (!window.treeList[id].imageryLayer && (typeof (visible) == "undefined" || visible)) {
                myLayer = createLayer(thisLayerInfo, layerCount);
                if (myLayer) {
                    if (this.isbasemap) {
                        this.lowerToBottom();
                    }
                    myLayer.NAME = thisLayerInfo.NAME;
                    //  cesium.layer3DList[id] = myLayer;
                    window.treeList[id].imageryLayer = myLayer
                    isLoad = true;
                }
                this.changeLayerTransparent(id, thisLayerInfo)
            } else if (window.treeList[id].imageryLayer) {
                if (typeof (visible) != "undefined") {
                    if (!visible) {
                        deleteServerTypeMap(id, thisLayerInfo);
                    }
                } else {
                    deleteServerTypeMap(id, thisLayerInfo);
                }
            }
            this.isload = isLoad;
            // loading.close()
            return myLayer;
        } catch (error) {

        }

    }

    LayerHelper.changeLayerTransparent = function (id, thisLayerInfo, opacity) {
        if (!opacity && opacity != 0) {
            opacity = 1
        }
        layerTransparent[id] = opacity;
        var thisLayer = window.treeList[id].imageryLayer;
        var servicetype = thisLayerInfo.hasOwnProperty("SERVICETYPE") ? thisLayerInfo.SERVICETYPE : "tile"; //图层类型
        var source = thisLayerInfo.hasOwnProperty("SOURCE") ? thisLayerInfo.SOURCE : "";
        switch (servicetype) {
            case sw_servicetype.sw_tile: //切片
                {
                    switch (source) {
                        case sw_source.sw_xyz:
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_arcgis:
                        case sw_source.sw_arcgistile:
                            //arcgisserver-Arcgis切片服务处理
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_osm:
                            // osm开源世界地图（OpenStreetMap）服务处理
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_wms:
                            //wms网络地图服务处理
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_wmts:
                            //wmts-web地图瓦片服务处理
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_pbf:
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_mongodb:
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_baidu:
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_gaode:
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_google:
                            //mongodb自定义服务处理
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_tianditu:
                            //mongodb自定义服务处理
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_template:
                            thisLayer.alpha = opacity;
                            break;
                        case sw_source.sw_gdaltile:
                            thisLayer.alpha = opacity;
                            break;
                        default:
                            break;
                    }
                    break;
                }
            case sw_servicetype.sw_terrain: //地形
                {
                    //viewer.scene.terrainProvider = new Cesium.EllipsoidTerrainProvider({});
                    console.log("地形不支持透明度调整！");
                    break;
                }
            case sw_servicetype.sw_oblique: //倾斜模型
                {
                    thisLayer.style = new Cesium.Cesium3DTileStyle({
                        color: "color('rgba(255,255,255," + opacity + ")')",
                    });
                    break;
                }
            case sw_servicetype.sw_gltf: //倾斜模型
                {
                    thisLayer.style = new Cesium.Cesium3DTileStyle({
                        color: "color('rgba(255,255,255," + opacity + ")')",
                    });
                    break;
                }
            case "undefined":
                break;
            default:
                break;
        }

    }

    function createLayer(myLayerInfo, layerIndex) {
        var layerType = 3;
        var thisLayer = null;
        var thisService = null;
        //属性
        var servicetype = myLayerInfo.hasOwnProperty("SERVICETYPE") ? myLayerInfo.SERVICETYPE : "tile"; //图层类型
        var source = myLayerInfo.hasOwnProperty("SOURCE") ? myLayerInfo.SOURCE : "";
        var status = myLayerInfo.hasOwnProperty("STATUS") ? myLayerInfo.STATUS : "";

        var source_type = myLayerInfo.hasOwnProperty("type") ? myLayerInfo.type : "";
        if (!source && (source_type == 0 || source_type)) {
            if (sw_source_type[source_type]) {
                source = sw_source_type[source_type]
            } else {
                servicetype = sw_service_type[source_type]
            }
        }
        var isOrder = true;

        var sw_status = {
            sw_online: "online",
            sw_offline: "offline"
        };
        switch (servicetype) {
            case sw_servicetype.sw_tile: //切片
                //#region 根据不同数据源进行加载设置
                switch (source) {
                    case sw_source.sw_xyz:
                        //xyz-谷歌/高德服务处理
                        if (status == sw_status.sw_online) {
                            thisService = new TileXYZService(myLayerInfo);
                        } else if (status == sw_status.sw_offline) {

                        }
                        break;
                    case sw_source.sw_arcgis:
                        //arcgisserver-Arcgis切片服务处理
                        thisService = new ArcgisService(myLayerInfo);
                        break;
                    case sw_source.sw_arcgistile:
                        //arcgisserver-Arcgis切片服务处理
                        thisService = new TileArcgisService(myLayerInfo);
                        break;
                    case sw_source.sw_osm:
                        // osm开源世界地图（OpenStreetMap）服务处理
                        thisService = new TileOSMService(myLayerInfo);
                        break;
                    case sw_source.sw_wms:
                        //wms网络地图服务处理
                        thisService = new TileWMSService(myLayerInfo);
                        break;
                    case sw_source.sw_wmts:
                        //wmts-web地图瓦片服务处理
                        thisService = new TileWMTSService(myLayerInfo);
                        break;
                    case sw_source.sw_pbf:
                        //pbf矢量切片服务处理
                        thisService = new MVTVectorService(myLayerInfo);
                        break;
                    case sw_source.sw_mongodb:
                        //mongodb自定义服务处理
                        thisService = new TileMongodbService(myLayerInfo);
                        break;
                    case sw_source.sw_baidu:
                        //百度服务处理
                        thisService = new BaiduMapService(myLayerInfo);
                        break;
                    case sw_source.sw_gaode:
                        //高德服务处理
                        thisService = new GaodeMapService(myLayerInfo);
                        break;
                    case sw_source.sw_google:
                        //谷歌服务处理
                        thisService = new GoogleMapService(myLayerInfo);
                        break;
                    case sw_source.sw_tianditu:
                        //天地图服务处理
                        thisService = new TiandituMapService(myLayerInfo);
                        break;
                    case sw_source.sw_template:
                        //模板服务处理
                        thisService = new TemplateMapService(myLayerInfo);
                        break;
                    case sw_source.sw_gdaltile:
                        //gdal
                        thisService = new SWImageMapService(myLayerInfo);
                    case sw_source.sw_streetmap:
                        thisService = new StreetMapService(myLayerInfo);
                    case sw_source.sw_tianditu_tile:
                        thisService = new TileTiandituService(myLayerInfo);
                    default:
                        break;
                }
                break;
            case sw_servicetype.sw_vector: //矢量
                thisService = new VectorService(myLayerInfo);
                break;
            case sw_servicetype.sw_terrain: //地形
                thisService = new TerrainService(myLayerInfo);
                isOrder = false;
                break;
            case sw_servicetype.sw_oblique: //倾斜
                thisService = new ObliqueService(myLayerInfo);
                isOrder = false;
                break;
            case sw_servicetype.sw_gltf: //gltf
                thisService = new GltfService(myLayerInfo);
                isOrder = false;
                break;
            case sw_servicetype.sw_poi: //poi
                thisService = new PoiService(myLayerInfo);
                isOrder = false;
                break;
            case sw_servicetype.sw_geojson://geojson
                thisService = new GeoJsonService(myLayerInfo);
                isOrder = false;
                break;
            case sw_servicetype.sw_lgx://lgx
                thisService = new LGXServer(myLayerInfo);
                isOrder = false;
                break;
            case sw_servicetype.sw_nmlw://路网
                thisService = new NMLWServer(myLayerInfo);
                isOrder = false;
                break;
            case sw_servicetype.sw_nmpoi://兴趣点json
                thisService = new PrimitivePointService(myLayerInfo);
                isOrder = false;
                break;
            case sw_servicetype.sw_json://json
                thisService = new OpenJsonService(myLayerInfo);
                isOrder = false;
                break;
            case sw_servicetype.sw_jsoninfo://jsoninfo
                thisService = new LoadJsonServer(myLayerInfo);
                isOrder = false;
                break;
        }
        if (thisService != null) {
            thisLayer = thisService.CreateLayer(viewer);
        }

        //对图层类型进行绑定
        thisLayer = thisLayer || {};
        if (myLayerInfo) {
            thisLayer["NAME"] = myLayerInfo["ALIAS"];
            thisLayer["URL"] = myLayerInfo["URL"];
        }
        thisLayer["SERVICETYPE"] = servicetype;
        thisLayer["SOURCE"] = source;
        thisLayer["GLOBALVISIBLE"] = true;
        return thisLayer;
    }
    // /**
    //  * 删除指定ID的图层
    //  */
    function deleteServerTypeMap(id, layerInfo) {
        var servicetype = layerInfo.hasOwnProperty("SERVICETYPE") ? layerInfo.SERVICETYPE : "tile"; //图层类型
        var source = layerInfo.hasOwnProperty("SOURCE") ? layerInfo.SOURCE : "";
        var imageryLayer = window.treeList[id].imageryLayer
        switch (servicetype) {
            case sw_servicetype.sw_tile: //切片
                {
                    viewer.scene.imageryLayers.remove(imageryLayer);
                    // window.treeList[id].imageryLayer = null

                    break;
                }
            case sw_servicetype.sw_terrain: //地形
                {
                    viewer.scene.terrainProvider = new Cesium.EllipsoidTerrainProvider({});

                    break;
                }
            case sw_servicetype.sw_oblique: //倾斜模型
                {
                    window.treeList[id].imageryLayer.show = false;
                    window.treeList[id].imageryLayer["GLOBALVISIBLE"] = false;
                    break;
                }
            case sw_servicetype.sw_gltf: //gltf
                window.treeList[id].imageryLayer.show = false;
                break;
            case sw_servicetype.sw_poi: //poi
                if (window.treeList[id].imageryLayer) {
                    window.treeList[id].imageryLayer.show = false;
                    return
                    var entities = window.treeList[id].imageryLayer.entities.values;
                    for (var i = 0; i < entities.length; i++) {
                        entities[i].show = false;
                    }
                }
                break;
            case sw_servicetype.sw_geojson: //geojson
                if (window.treeList[id].imageryLayer) {
                    window.treeList[id].imageryLayer.show = false;
                    return
                }
                break;
            case sw_servicetype.sw_lgx: //lgx
                // globleStreamerpath.removeprimitive(id);


                break;
            case sw_servicetype.sw_nmlw: //nmlw
                var entities = window.treeList[id].imageryLayer._entityCollection._entities._array;
                for (var i = 0; i < entities.length; i++) {
                    entities[i].show = false;
                }
                break;
            case sw_servicetype.sw_nmpoi: //nmlw
                window.treeList[id].imageryLayer.SetVisible(false);
                break;
            case sw_servicetype.sw_json: //json
                if (window.treeList[id].imageryLayer) {
                    window.treeList[id].imageryLayer.SetVisible(false);
                }
                break;
            case sw_servicetype.sw_jsoninfo: //jsoninfo
                if (window.treeList[id].imageryLayer) {
                    window.treeList[id].imageryLayer.SetVisible(false);
                }
                break;
            case "undefined":
                break;
            default:
                break;
        }
        window.treeList[id].imageryLayer = null
    }
    return LayerHelper;
}
var layerTransparent = {};
export function checkLayerTransparent(layer, id, alpha) {
    if (layerTransparent[id]) {
        layer.alpha = layerTransparent[id];
    } else if (alpha) {
        layer.alpha = alpha;
    }
}