﻿/*
 * @Descripttion: 
 * @version: 
 * @Author: 牛夏蕊
 * @Date: 2022-07-29 11:23:34
 * @LastEditors: 牛夏蕊
 * @LastEditTime: 2022-08-02 09:30:45
 */
import * as Cesium from "cesium";
import { checkLayerTransparent } from "@/utils/map/layerHelper"
//arcgis服务
export function ArcgisService(layerInfo) {
    var ArcgisService = new Object;
    ArcgisService.id = layerInfo.hasOwnProperty("GUID") ? layerInfo.GUID : "";
    ArcgisService.url = layerInfo.hasOwnProperty("URL") ? layerInfo.URL : "";
    ArcgisService.name = layerInfo.hasOwnProperty("NAME") ? layerInfo.NAME : "";
    ArcgisService.servertype = layerInfo.hasOwnProperty("SERVERTYPE") ? layerInfo.SERVERTYPE : "";
    ArcgisService.showLayer = (layerInfo.hasOwnProperty("PARAMETERS") && layerInfo.PARAMETERS != "") ? layerInfo.PARAMETERS : layerInfo.ID;
    ArcgisService.transparent = (layerInfo.hasOwnProperty("transparent") && layerInfo.transparent != "") ? layerInfo.transparent : "";
    ArcgisService.layerindex = (layerInfo.hasOwnProperty("layerindex") && layerInfo.layerindex != "") ? layerInfo.layerindex : "";

    ArcgisService.CreateLayer = function (viewer) {
        var id = this.id;
        var url = this.url;
        var name = this.name;
        var servertype = this.servertype;
        var showLayer = this.showLayer == "" ? "" : "show:" + this.showLayer;
        var proxyUrl = "";
        var layers = viewer.imageryLayers;
        // var layerindex = layers._layers.length;

        var layerindex = (this.layerindex != "" && this.layerindex > layers._layers.length) ? layers._layers.length : layerindex;
        var transparent = this.transparent;

        var thisLayer = layers.addImageryProvider(new Cesium.ArcGisMapServerImageryProvider({
            url: url,
            enablePickFeatures: false
        }), layerindex);
        checkLayerTransparent(thisLayer, id, transparent);
        return thisLayer;
    }
    return ArcgisService;
}