/*
 * @Descripttion: 
 * @version: 
 * @Author: 牛夏蕊
 * @Date: 2022-07-29 11:23:34
 * @LastEditors: 牛夏蕊
 * @LastEditTime: 2022-08-06 12:48:20
 */
//lgx加载
import * as Cesium from "cesium";
import { flyByRectangle } from "@/utils/map/mapUtils"

export function LGXServer(layerInfo) {
    var LGXServer = new Object;
    LGXServer.id = layerInfo.hasOwnProperty("GUID") ? layerInfo.GUID : "";
    LGXServer.style = layerInfo.hasOwnProperty("STYLE") ? layerInfo.STYLE : "#0033FF";
    LGXServer.lineWidth = layerInfo.hasOwnProperty("WIDTH") ? layerInfo.WIDTH : 5;
    LGXServer.speed = layerInfo.hasOwnProperty("SPEED") ? layerInfo.SPEED : 1;
    LGXServer.pointColor = layerInfo.hasOwnProperty("pointColor") ? layerInfo.pointColor : "#FFFFFF";
    LGXServer.url = layerInfo.hasOwnProperty("URL") ? layerInfo.URL : "";
    LGXServer.name = layerInfo.hasOwnProperty("NAME") ? layerInfo.NAME : "";
    LGXServer.CreateLayer = function (viewer) {
        var url = this.url;
        var promise = Cesium.GeoJsonDataSource.load(url, {
            clampToGround: true,
            crsNames: "EPSG:4525",
        })
        var that = this;
        promise.then((dataSource) => {
            let entities = dataSource.entities.values
            //动态纹理
            // for (let o = 0; o < entities.length; o++) {
            //     let r = entities[o];
            //     r.polyline.material = material;
            //     r.polyline.width = 6;
            // }
            // var thisLayer = dataSource;
            // viewer.dataSources.add(dataSource);
            // thisLayer.NAME = that.name;
            // cesium.layer3DList[that.id] = thisLayer;
            //流光并计算四至范围
            var allPoints = [];
            var turfPolyline = null;
            var turfP = [];
            for (let o = 0; o < entities.length; o++) {
                var positions = entities[o].polyline._positions._value;
                var points = [];
                for (var i = 0; i < positions.length; i++) {
                    var position = positions[i];
                    var cartographic = Cesium.Cartographic.fromCartesian(position);
                    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
                    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
                    turfP.push([longitude, latitude]);
                    points.push(longitude);
                    points.push(latitude);
                }
                allPoints.push(points);
            }
            turfPolyline = turf.lineString(turfP);
            var box = turf.bbox(turfPolyline);
            flyByRectangle({
                "MINX": box[0],
                "MINY": box[1],
                "MAXX": box[2],
                "MAXY": box[3]
            })
            var obj = {
                positions: allPoints,//positions 经纬度二维数组，没有高度 position 经纬度数组，没有高度
                //position:[112.5220237760754713, 37.8643118141969666,112.5201885781767999, 37.8726141616944716]
                lineColor: that.style,//线的颜色
                lineAlpha: 1.0,//线的透明度
                linewidth: that.lineWidth,//线的宽度
                pointColor: that.pointColor,//移动点的颜色
                pointAlpha: 1.0,//移动点的透明度
                id: that.id,//
                speed: that.speed//移动速度
            }
            // globleStreamerpath.create(obj);
            // cesium.layer3DList[that.id] = obj;
            window.treeList[id].imageryLayer = obj
        })
        // return {};
    }
    return LGXServer;
}