﻿/*
 * @Descripttion: 
 * @version: 
 * @Author: 牛夏蕊
 * @Date: 2022-07-29 11:23:34
 * @LastEditors: 牛夏蕊
 * @LastEditTime: 2022-08-10 17:46:09
 */
//MVTVectorService服务
import * as Cesium from "cesium";
import { flyByRectangle } from "@/utils/map/mapUtils"
import mapRequest from "@/utils/map/mapRequest";
export function MVTVectorService(layerInfo) {
    var MVTVectorService = new Object;
    MVTVectorService.layerid = "";
    MVTVectorService.id = layerInfo["GUID"] || "";
    MVTVectorService.url = layerInfo["URL"] || "";
    MVTVectorService.name = layerInfo["NAME"] || "";
    MVTVectorService.DATAURI = layerInfo["DATAURI"] || "";
    MVTVectorService.LAYERNAME = layerInfo["LAYERNAME"] || "";
    MVTVectorService.SPATIALREF = layerInfo["SPATIALREF"] || "";
    MVTVectorService.request = import.meta.env.VITE_GDAL_API;
    MVTVectorService.extent = null;
    MVTVectorService.CreateLayer = function (viewer) {
        var that = this;
        let data = null;
        // $.ajaxSettings.async = false;
        // 发送请求
        mapRequest({
            url: this.request + '/gdal/vector/cachelayer',
            method: 'post',
            params: JSON.stringify({
                "LAYERDEF": {
                    "DATAURI": this.DATAURI,
                    "LAYERNAME": this.LAYERNAME,
                    "SPATIALREF": this.SPATIALREF
                }
            }).then((res) => {
                data = typeof res == "string" ? JSON.parse(res) : res
                if (data && data.LAYERID) {
                    var layerId = data.LAYERID;
                    if (layerId != null) {
                        that.layerid = layerId;
                        that.extent = data.LAYERINFO.EXTENT;
                        that.extent["name"] = that.LAYERNAME;
                    }
                    // var url = this.request + "/gdal/tilexyz/" + this.layerid + "/3857/{z}/{x}/{y}.pbf";
                    // var thisLayer = viewer.imageryLayers.addImageryProvider(createMVTWithStyle(Cesium, ol,
                    //     createMapboxStreetsV6Style, {
                    //         url: url,
                    //         //key: key
                    //     }));
                    var mvtLayer = new Cesium.MvtImageryProvider({
                        layers: that.id,
                        url: that.request + "/gdal/tilexyz/" + that.layerid + "/3857/{z}/{x}/{y}.pbf",
                        //url: "http://192.168.100.10:8080/gdal/tilexyz/3d6e4bb88ec8ebac48f61ccedb265af1/3857/8/201/95.pbf",
                        //url: 'http://localhost:9080/pg_postgis_mvt/api/v1/district/{z}/{x}/{y}',
                        // url: 'https://a.tiles.mapbox.com/v4/mapbox.mapbox-streets-v6/{z}/{x}/{y}.vector.pbf?access_token={k}',
                        // key: 'pk.eyJ1IjoibXV5YW8xOTg3IiwiYSI6ImNpcm9ueHd6cjAwNzZoa20xazY1aWlubjIifQ.5tLtC5j1rh8Eqjlyrq3OaA',
                        style: new Cesium.MvtStyle.MapboxStreetsV6()
                    });
                    var thisLayer = viewer.imageryLayers.addImageryProvider(mvtLayer);
                    flyByRectangle(that.extent);
                    window.treeList[id].imageryLayer = thisLayer
                    // return thisLayer;
                } else {
                    console.log("矢量数据请求失败！");
                }
            })
        })

    }
    return MVTVectorService;
}