/*
 * @Descripttion: 
 * @version: 
 * @Author: 牛夏蕊
 * @Date: 2022-07-29 11:23:34
 * @LastEditors: 牛夏蕊
 * @LastEditTime: 2022-08-06 11:29:32
 */
//lgx加载
import * as Cesium from "cesium";
import { checkLayerTransparent } from "@/utils/map/layerHelper"

export function NMLWServer(layerInfo) {
    var NMLWServer = new Object;
    NMLWServer.id = layerInfo.hasOwnProperty("GUID") ? layerInfo.GUID : "";
    NMLWServer.style = layerInfo.hasOwnProperty("STYLE") ? layerInfo.STYLE : "#0033FF";
    NMLWServer.lineWidth = layerInfo.hasOwnProperty("WIDTH") ? layerInfo.WIDTH : 5;
    NMLWServer.speed = layerInfo.hasOwnProperty("SPEED") ? layerInfo.SPEED : 1;
    NMLWServer.pointColor = layerInfo.hasOwnProperty("pointColor") ? layerInfo.pointColor : "#FFFFFF";
    NMLWServer.url = layerInfo.hasOwnProperty("URL") ? layerInfo.URL : "";
    NMLWServer.name = layerInfo.hasOwnProperty("NAME") ? layerInfo.NAME : "";
    NMLWServer.CreateLayer = function (viewer) {
        var url = this.url;
        let thisLayer;

        var globleDataSources = {};
        this.getObjectInfo = function (param) {
            var bool = false;
            for (var attr in param) {
                bool = true;
            }
            return bool;
        }
        this.handleNMLW = function (visible) {
            for (var attr in globleDataSources) {
                globleDataSources[attr].show = visible;
            }
        }
        // if (this.getObjectInfo(globleDataSources)) {
        //     this.handleNMLW(true);
        //     return;
        // }
        let promise = Cesium.GeoJsonDataSource.load(url, {
            clampToGround: true,
        })
        let that = this;
        promise.then((dataSource) => {
            let values = dataSource.entities.values;
            let type1 = {
                "style": new xt3d.PolylineObject.PolylineSpriteMaterialProperty({
                    duration: 2000, //控制速度
                    url: './img/line1.png', //材质路径
                }),
                "distanceDisplayCondition": 30000,
            };
            let type2 = {
                "style": new xt3d.PolylineObject.PolylineSpriteMaterialProperty({
                    duration: 2000, //控制速度
                    url: "./img/line2.png", //材质路径
                }),
                "distanceDisplayCondition": 150000,
            };
            let type3 = {
                "style": new xt3d.PolylineObject.PolylineSpriteMaterialProperty({
                    duration: 2000, //控制速度
                    url: "./img/line3.png", //材质路径
                }),
                "distanceDisplayCondition": 50000000,
            };
            let config = {
                "-": type1,
                '普通': type1,
                '次干路': type1,
                '县道': type1,
                '乡道': type1,
                '支路': type1,
                '快速路': type2,
                '连接道': type2,
                '主干路': type2,
                '专用公路': type2,
                '高速': type3,
                '国道': type3,
                '省道': type3
            }

            for (let i = 0; i < values.length; i++) {
                let type = values[i]._properties.TYPE._value;
                if (!globleDataSources[type]) {
                    globleDataSources[type] = new Cesium.CustomDataSource("datasource_" + type);
                    viewer.dataSources.add(globleDataSources[type]);
                }
                values[i].polyline.material = config[type].style || type3.style;
                values[i].polyline.width = 3;
                values[i].polyline.distanceDisplayCondition = new Cesium.DistanceDisplayCondition(0, config[type].distanceDisplayCondition);
                globleDataSources[type].entities.add(values[i]);
            }
            thisLayer = dataSource;
            thisLayer.NAME = that.name;
            window.treeList[id].imageryLayer = thisLayer
            // cesium.layer3DList[that.id] = thisLayer;
        })
        // .otherwise(function (error) {
        //     console.log(error)
        // });
        // return {};
    }
    return NMLWServer;
}