﻿//倾斜服务
import * as Cesium from "cesium";
import {checkLayerTransparent} from "@/utils/map/layerHelper"

var tileset = null;
export function ObliqueService(layerInfo) {
    var ObliqueService = new Object;
    ObliqueService.id = layerInfo.hasOwnProperty("GUID") ? layerInfo.GUID : "";
    ObliqueService.url = layerInfo.hasOwnProperty("URL") ? layerInfo.URL.replace("http://:", "http://") : "";
    ObliqueService.name = layerInfo.hasOwnProperty("NAME") ? layerInfo.NAME : "";
    ObliqueService.servertype = layerInfo.hasOwnProperty("SERVERTYPE") ? layerInfo.SERVERTYPE : "";
    ObliqueService.CreateLayer = function (viewer) {
        var url = this.url.replace("http://http://","http://");
        var id = this.id;
        var name = this.name;
        var thisLayer = null;
        //加载倾斜摄影
        // var translation=Cesium.Cartesian3.fromArray([111.679225, 40.862803, -1710]);
        // var m= Cesium.Matrix4.fromTranslation(translation);
        // var tileset = new Cesium.Cesium3DTileset({
        //     //相对路径
        //     url: url,
        //     skipLevelOfDetail : true,
        //     maximumScreenSpaceError: 128,
        //     //maximumMemoryUsage: 102.4, //瓦片集可以使用的最大内存量（以 MB 为单位）。
        //     // cullWithChildrenBounds: false, //优化选项。是否使用子边界体积的并集来剔除瓦片。
        //     // maximumScreenSpaceError: 2 , // 用于驱动细节细化级别的最大屏幕空间误差。
        //     // preloadFlightDestinations: false , //优化选项。在相机飞行时在相机的飞行目的地预加载图块。
        //     // preferLeaves: true , //优化选项。最好先装载叶子。
        //     dynamicScreenSpaceError: true , //优化选项。减少距离相机较远的图块的屏幕空间错误。
        //     // progressiveResolutionHeightFraction: 0.4 , // 优化选项。如果介于 (0.0, 0.5] 之间，则屏幕空间错误或高于屏幕空间错误的图块progressive
        //     foveatedScreenSpaceError: true, //优化选项。通过暂时提高屏幕边缘周围图块的屏幕空间错误，优先加载屏幕中心的图块。一旦Cesium3DTileset#foveatedConeSize加载确定的屏幕中心的所有图块，屏幕空间错误就会恢复正常。
        //     // //foveatedConeSize: 0.05 , //优化选项。当Cesium3DTileset#foveatedScreenSpaceError为 true 时使用来控制决定延迟哪些图块的锥体大小。立即加载此圆锥内的瓷砖。圆锥外的瓷砖可能会根据它们在圆锥外的距离及其屏幕空间误差而延迟。这是由Cesium3DTileset#foveatedInterpolationCallback和控制的Cesium3DTileset#foveatedMinimumScreenSpaceErrorRelaxation。将此设置为 0.0 意味着圆锥将是由相机位置及其视图方向形成的线。将此设置为 1.0 意味着锥体包含相机的整个视野​​，禁用效果。
        //     //foveatedMinimumScreenSpaceErrorRelaxation: 0.0, // 优化选项。当Cesium3DTileset#foveatedScreenSpaceError为 true 时使用以控制中央凹锥之外的图块的起始屏幕空间误差松弛。屏幕空间错误将从 tileset 值开始Cesium3DTileset#maximumScreenSpaceError根据提供的Cesium3DTileset#foveatedInterpolationCallback.
        //     foveatedTimeDelay: 0.0, //优化选项。使用 whenCesium3DTileset#foveatedScreenSpaceError为 true 来控制在相机停止移动后延迟瓷砖开始加载之前等待的时间（以秒为单位）。此时间延迟可防止在相机移动时请求屏幕边缘周围的瓷砖。将此设置为 0.0 将立即请求任何给定视图中的所有图块。
        //     //skipLevels: 13,
        //     //skipScreenSpaceErrorFactor: 256,
        //     //immediatelyLoadDesiredLevelOfDetail: true,
        //     //modelMatrix: m
        // });
        var tileset = new Cesium.Cesium3DTileset({
            url:url,
            skipLevelOfDetail: true,
            baseScreenSpaceError: 1024,
            maximumScreenSpaceError: 256, // 数值加大，能让最终成像变模糊
            skipScreenSpaceErrorFactor: 16,
            skipLevels: 1,
            immediatelyLoadDesiredLevelOfDetail: false,
            loadSiblings: true, // 如果为true则不会在已加载完概况房屋后，自动从中心开始超清化房屋
            cullWithChildrenBounds: true,
            cullRequestsWhileMoving: true,
            cullRequestsWhileMovingMultiplier: 10, // 值越小能够更快的剔除
            preloadWhenHidden: true,
            preferLeaves: true,
            maximumMemoryUsage: 128, // 内存分配变小有利于倾斜摄影数据回收，提升性能体验
            progressiveResolutionHeightFraction: 0.5, // 数值偏于0能够让初始加载变得模糊
            dynamicScreenSpaceErrorDensity: 0.5, // 数值加大，能让周边加载变快
            dynamicScreenSpaceErrorFactor: 1, // 不知道起了什么作用没，反正放着吧先
            dynamicScreenSpaceError: true, // 根据测试，有了这个后，会在真正的全屏加载完之后才清晰化房屋
        });

        tileset.readyPromise.then(function (tileset) {
            //笛卡尔转换为弧度
            var cartographic = Cesium.Cartographic.fromCartesian(
                tileset.boundingSphere.center
            );
            var lng = Cesium.Math.toDegrees(cartographic.longitude); //使用经纬度和弧度的转换，将WGS84弧度坐标系转换到目标值，弧度转度
            var lat = Cesium.Math.toDegrees(cartographic.latitude);
            //计算中心点位置的地表坐标
            var surface = Cesium.Cartesian3.fromDegrees(lng, lat, 0);
            //偏移后的坐标
            var offset = Cesium.Cartesian3.fromDegrees(lng, lat, 0);
            var translation = Cesium.Cartesian3.subtract(
                offset,
                surface,
                new Cesium.Cartesian3()
            );
            tileset.modelMatrix = Cesium.Matrix4.fromTranslation(translation);
        });
        //添加到球体上
        var thisLayer = viewer.scene.primitives.add(tileset);
        return thisLayer;
    }
    return ObliqueService;
}