﻿/*
 * @Descripttion: 
 * @version: 
 * @Author: 牛夏蕊
 * @Date: 2022-07-29 11:23:34
 * @LastEditors: 牛夏蕊
 * @LastEditTime: 2022-08-06 11:46:51
 */
//poi
var poiItems;

import * as Cesium from "cesium";
import { checkLayerTransparent } from "@/utils/map/layerHelper"

export function PoiService(layerInfo) {
    var PoiServiceLayer = new Object;
    PoiServiceLayer.id = layerInfo.hasOwnProperty("GUID") ? layerInfo.GUID : "";
    PoiServiceLayer.position = layerInfo.hasOwnProperty("POSITION") ? layerInfo.POSITION : "";
    PoiServiceLayer.url = layerInfo.hasOwnProperty("URL") ? layerInfo.URL.replace("http://:", "http://") : "";
    PoiServiceLayer.name = layerInfo.hasOwnProperty("NAME") ? layerInfo.NAME : "";
    PoiServiceLayer.servertype = layerInfo.hasOwnProperty("SERVERTYPE") ? layerInfo.SERVERTYPE : "";
    PoiServiceLayer.CreateLayer = function () {
        var url = this.url.replace("http://http://", "http://");
        var labelField = "Name";
        var labelFont = "13px";
        var labelColor = "#ffffff";
        var labelBackground = "#0000ff";
        var labelHeight = -50;
        Cesium.GeoJsonDataSource.load(url, {
            // clampToGround: true
        }).then(function (dataSource) {
            var allPoints = [];
            var entities = dataSource.entities.values;
            // for (var i = 0 ; i < entities.length ; i ++){
            //     var entity = entities[i];
            //     var position = entity.position._value;
            //     allPoints.push(position);
            // }
            //TODO 计算点的高程值
            //var promise = Cesium.sampleTerrain(viewer.terrainProvider, 15, allPoints);
            //Cesium.when(promise, function(updatedPositions) {
            //allPoints = updatedPositions;
            for (var i = 0; i < entities.length; i++) {
                var entity = entities[i];
                var position = entity.position._value;
                var cartographic = Cesium.Cartographic.fromCartesian(position);
                var longitude = Cesium.Math.toDegrees(cartographic.longitude);
                var latitude = Cesium.Math.toDegrees(cartographic.latitude);
                //var height = viewer.scene.sampleHeight(new Cesium.Cartographic(position.x, position.y));
                // var position = entity.position.(Cesium.JulianDate.now());
                // entity.position = viewer.scene.clampToHeight(position);
                entity.position = position;

                // entity.position = Cesium.Cartesian3.fromDegreesArrayHeights([longitude, latitude, Cesium.Cartographic.fromCartesian(viewer.scene.clampToHeight(position)).height + 2])[0];
                // entity.billboard = undefined;
                // entity.point = {
                //     heightReference: Cesium.HeightReference.CLAMP_TO_GROUND,
                //     pixelSize: 10,
                //     color: Cesium.Color.RED.withAlpha(0)
                // };

                entity.label = {
                    text: entity._properties.getValue("")[labelField],
                    font: labelFont,
                    // fillColor: !labelColor ? Cesium.Color.WHITE : Cesium.Color.fromCssColorString(labelColor),
                    fillColor: Cesium.Color.WHITE,
                    style: Cesium.LabelStyle.FILL,
                    showBackground: false,
                    verticalOrigin: Cesium.VerticalOrigin.CENTER,//垂直位置
                    horizontalOrigin: Cesium.HorizontalOrigin.LEFT,//水平位置
                    distanceDisplayCondition: new Cesium.DistanceDisplayCondition(0.0, 10000.0),
                    // backgroundColor: new Cesium.Color(0 / 255, 54 / 255, 154 / 255, 1.0),
                    // backgroundPadding: new Cesium.Cartesian2(3, 3),
                    pixelOffset: new Cesium.Cartesian2(75, -100),
                    heightReference: Cesium.HeightReference.CLAMP_TO_GROUND
                };
                entity.billboard = {
                    //image: require('../../../img/广告牌.png'),
                    image: '/MapServer/Portal/img/billboard.png',
                    width: 160,
                    height: 90,
                    pixelOffset: new Cesium.Cartesian2(100, -35),   //偏移量
                    horizontalOrigin: Cesium.HorizontalOrigin.CENTER,
                    // image: pinBuilder.fromText(name, Cesium.Color.BLUE.withAlpha(0.75), 48).toDataURL(),
                    distanceDisplayCondition: new Cesium.DistanceDisplayCondition(0.0, 2000.0),
                    verticalOrigin: Cesium.VerticalOrigin.BOTTOM,
                    scale: 1
                };
            }
            thisLayer = dataSource;
            viewer.dataSources.add(thisLayer);
            thisLayer.NAME = poiItems.name;
            window.treeList[id].imageryLayer = thisLayer
            // cesium.layer3DList[poiItems.id] = thisLayer;
            //}.bind(this));

        }.bind(this));
        // return {};
    }
    poiItems = PoiServiceLayer;
    return PoiServiceLayer;
}