import { getHeightByType } from "@/utils/map/mapUtils";

//不动产查询服务
var ellipsoid;
var heigthfool;//模型高度
var featuresdata;//请求结果
var urlgeojson = '/MapServer/Portal/data/b3.json';
var color = [
    "#00F5FF",
    "#00B2EE",
    "#00FF00",
    "#EEEE00",
    "#FFA500",
    "#FF4500",
    "#FF7256",
    "#DC143C",
    "#EE00EE",
    "#CDBE70"
];//默认颜色集合
var realEstatePathInfoDOM;//户型信息弹窗
var realEstateLayerInfoDom;//户型信息弹窗图片、视频窗口
var EntityLayer = new Cesium.CustomDataSource("build_11");
var SZC;//所在层
var modelID = "6d0fc57Afe3E47Cb9469fBbAFf8a1B06"
var visible = true;

/**
 * 打开d3模型，并开始查询
 */
function loadD3model() {
    if (!visible) {
        visible = true;
        cesium.layer3DList[modelID].show = true;
        cesium.layer3DList[modelID]["GLOBALVISIBLE"] = true;
        startSelect();
        return;
    }
    var layerInfo;
    ellipsoid = viewer.scene.globe.ellipsoid;
    viewer.dataSources.add(EntityLayer);
    $.ajax({
        type: "post",
        async: false,
        url: modelURL + "resource/getResourcesByGuid",
        data: {
            guid: modelID
        },
        datatype: "json",
        crossDomain: false,
        xhrFields: {
            withCredentials: false
        },
        success: function (result) {
            var data = typeof (result) == "string" ? JSON.parse(result) : result;
            if (data.code == 200) {
                layerInfo = data.data[0]
                if (layerInfo && layerInfo != {} && layerInfo != []) {
                    layerInfo["URL"] = layerInfo.ADDRESS;
                }
            }
        },
        error: function (err) { }
    });

    try {
        var layerHelper = new LayerHelper(layerInfo);
        layerHelper.addLayer(true);
        viewer.zoomTo(cesium.layer3DList[modelID]);
        startSelect();
        closeSelectModelServer();
    } catch (e) { }
}


/**
 * 开始查询
 */
function startSelect() {
    viewer.screenSpaceEventHandler.setInputAction(function onLeftClick(movement) {
        var pickedFeature = viewer.scene.pick(movement.position);
        var position2 = viewer.scene.pickPosition(movement.position);
        var cartographic2 = ellipsoid.cartesianToCartographic(position2);
        var longitude = Cesium.Math.toDegrees(cartographic2.longitude); //经度
        var latitude = Cesium.Math.toDegrees(cartographic2.latitude); //纬度
        heigthfool = cartographic2.height / 3
        heigthfool = parseInt(heigthfool);
        let allPoints = [];
        allPoints.push(Cesium.Cartographic.fromDegrees(longitude, latitude));
        getHeightByType(allPoints, 'terrain').then(results => {
            SZC = (cartographic2.height - (results[0]["height"] || 0)) / 3;
            SZC = parseInt(SZC);
            SZC == 0 ? SZC = 1 : SZC;
            if (typeof (pickedFeature) != "undefined") {//鼠标是否选中模型
                if (pickedFeature.id) {
                    if (pickedFeature.id._id.indexOf("floor") == -1) {//id是否包含floor，包否代表点击了层，否则点击了户
                        EntityLayer.entities.removeById("001_000");//清除选中状态
                        let polygonF = turf.polygon([getgeomarybyid(pickedFeature.id._id)]);
                        let buffered = turf.buffer(polygonF, 1.5, { units: 'meters' });
                        let coordinates = buffered.geometry.coordinates;
                        var points = coordinates[0];
                        createExtrudedPolygon("001_000", points, heigthfool, "#ff0000");
                        creathtml(getinfobyid(pickedFeature.id._id), "3");
                        return;
                    }
                    EntityLayer.entities.removeAll()
                    realEstatePathInfoDOM && realEstatePathInfoDOM.remove();
                    getgeojsondata(urlgeojson, heigthfool);
                    creathtml({
                        "XQM": featuresdata[0].properties.XQM,
                        "LDH": featuresdata[0].properties.LDH,
                        "DYH": featuresdata[0].properties.DYH,
                        "SZC": SZC
                    }, "2");
                }
                EntityLayer.entities.removeAll()
                realEstatePathInfoDOM && realEstatePathInfoDOM.remove();
                getgeojsondata(urlgeojson, heigthfool);
                creathtml({
                    "XQM": featuresdata[0].properties.XQM,
                    "LDH": featuresdata[0].properties.LDH,
                    "DYH": featuresdata[0].properties.DYH,
                    "SZC": SZC
                }, "2");
            }
            else {
                EntityLayer.entities.removeAll()
            }
        })
    }, Cesium.ScreenSpaceEventType.LEFT_CLICK);

}


/**
 * 根据id查询多边形范围
 * @param id
 * @returns {*}
 */
function getgeomarybyid(id) {
    if (featuresdata) {
        for (let i = 0; i < featuresdata.length; i++) {
            if (id == featuresdata[i].properties.BDCDYH) {
                return geometrycoll = featuresdata[i].geometry.coordinates[0];
            }
        }
    }


}

/**
 * 根据id查询户室信息
 * @param id
 * @returns {*}
 */
function getinfobyid(id) {
    if (featuresdata) {
        for (let i = 0; i < featuresdata.length; i++) {
            if (id == featuresdata[i].properties.BDCDYH) {
                return geometrycoll = featuresdata[i].properties;
            }
        }
    }
}

/**
 * 创建多边形
 * @param id
 * @param polygonGeometry
 * @param height
 * @param color
 * @returns {Entity}
 */
function createExtrudedPolygon(id, polygonGeometry, height, color) {
    let Geometry = poiontstoarray(polygonGeometry);
    EntityLayer.entities.add({
        id: id,
        polygon: {
            hierarchy: new Cesium.PolygonHierarchy(
                Cesium.Cartesian3.fromDegreesArray(Geometry)
            ),
            height: height * 3,//底
            extrudedHeight: height * 3 + 3,//顶
            material: new Cesium.Color.fromCssColorString(color).withAlpha(1),
        }
    });
};

/**
 * 创建整栋楼多边形
 * @param id
 * @param polygonGeometry
 * @param height
 * @param color
 */
function createExtrudedPolygonallfloor(id, polygonGeometry, height) {
    height > 300 ? height = 346 : height = 0;
    let Geometry = poiontstoarray(polygonGeometry);
    EntityLayer.entities.add({
        id: id + "floor",
        polygon: {
            hierarchy: new Cesium.PolygonHierarchy(
                Cesium.Cartesian3.fromDegreesArray(Geometry)
            ),
            height: height * 3,//底
            extrudedHeight: height * 3 + 21,//顶
            material: new Cesium.Color.fromCssColorString("#ff0000").withAlpha(0.3),
        }
    });
};

/**
 * 请求数据
 * @param url
 * @param heigthfool
 */
function getgeojsondata(url, heigthfool) {
    $.get(url, function (data) {
        var josnN = typeof data == 'string' ? JSON.parse(data) : data;
        featuresdata = josnN.features;
        for (let i = 0; i < featuresdata.length; i++) {
            var pointcollection = featuresdata[i].geometry.coordinates[0];


            let polygonF = turf.polygon([pointcollection]);
            let buffered = turf.buffer(polygonF, 1, { units: 'meters' });
            let coordinates = buffered.geometry.coordinates;
            var points = coordinates[0];

            createExtrudedPolygon(featuresdata[i].properties.BDCDYH, points, heigthfool, color[i]);
            createExtrudedPolygonallfloor(featuresdata[i].properties.BDCDYH, pointcollection, heigthfool)
        }

    })

}

/**
 * 获取多边形集合并偏移
 * @param points
 * @returns {*[]}
 */
function poiontstoarray(points) {
    let degreesArray = [];
    for (let i = 0; i < points.length; i++) {
        let cartesianPos = Cesium.Cartesian3.fromDegrees(points[i][0], points[i][1], 0.0);
        let cartesianPos2 = new Cesium.Cartesian3(cartesianPos.x - 6.9, cartesianPos.y + 9.4, cartesianPos.z);
        var cartographic = ellipsoid.cartesianToCartographic(cartesianPos2);
        var lat = Cesium.Math.toDegrees(cartographic.latitude);
        var lng = Cesium.Math.toDegrees(cartographic.longitude);
        degreesArray.push(lng);
        degreesArray.push(lat);
    }
    return degreesArray;
}

/**
 * 创建信息展示表单
 * @param params
 * @param type 1:一栋楼  2：一层楼  3：一户人家
 */
function creathtml(params, type) {
    realEstatePathInfoDOM && realEstatePathInfoDOM.remove();
    var formDIV = document.createElement("div");
    formDIV.className = "realEstatePathInfoDOM";
    if (type) {
        switch (type) {
            case "1":
                //一栋楼的信息
                break;
            case "2":
                //一层楼的信息
                formDIV.style = "width: 400px; height: 294px;background: url(/MapServer/Portal/img/analysis/bdcbj.png) 100% 100% no-repeat;";
                // params.LCXX = "楼层信息"
                var html = ` <div style="width: 400px; height: 31px;" class="header">
                                <div style="height: 100%; width: 35%; float: left;" class="headerleft">
                                    <img style="margin-top: 8px;margin-left: 110px;" src="/MapServer/Portal/img/analysis/leftbj1.png">
                                </div>
                                <div style="height: 100%; width: 30%; float: left;" class="headermain">
                                    <span
                                        style="color: rgba(255, 255, 255, 1);font-size: 14px;line-height: 30px; margin-left: 37px;">层信息</span>
                                </div>
                                <div style="height: 100%; width: 30%;float: left;" class="headerright">
                                    <img style="margin-top: 8px;margin-left: -25px;" src="/MapServer/Portal/img/analysis/rightbj.png">
                                </div>
                                <div class="headerclose" style="float: right; width: 5%;">
                                    <img style="cursor:pointer" title="关闭" id="closerealEstatePathInfoDOM"
                                        src="/MapServer/Portal/img/realEstate/closewin.png">
                                </div>
                            </div>
                            <div style="width: 386px;margin-left: 8px;" class="bodyinfo">
                                <table style="width: 100%; border-collapse: collapse;">
                                    <tbody>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                小区名称</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.XQM + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                楼栋号</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.LDH + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                楼层</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.SZC + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                单元号</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            `+ params.DYH + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                户数</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            5</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                人数</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            12</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                说明</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            无</td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>`
                formDIV.innerHTML = html;
                realEstatePathInfoDOM = formDIV
                document.body.appendChild(realEstatePathInfoDOM);
                break;
            case "3":
                //户的信息
                formDIV.style = "width: 400px; height: 723px;background: url(/MapServer/Portal/img/analysis/bdcbj.png) -1px -1px no-repeat;background-size: 100% 100%;";

                var html = ` <div style="width: 400px; height: 31px;" class="header">
                                <div style="height: 100%; width: 35%; float: left;" class="headerleft">
                                    <img style="margin-top: 8px;margin-left: 110px;" src="/MapServer/Portal/img/analysis/leftbj1.png">
                                </div>
                                <div style="height: 100%; width: 30%; float: left;" class="headermain">
                                    <span
                                        style="color: rgba(255, 255, 255, 1);font-size: 14px;line-height: 30px; margin-left: 37px;">户信息</span>
                                </div>
                                <div style="height: 100%; width: 30%;float: left;" class="headerright">
                                    <img style="margin-top: 8px;margin-left: -25px;" src="/MapServer/Portal/img/analysis/rightbj.png">
                                </div>
                                <div class="headerclose" style="float: right; width: 5%;">
                                    <img style="cursor:pointer" title="关闭" id="closerealEstatePathInfoDOM"
                                        src="/MapServer/Portal/img/realEstate/closewin.png">
                                </div>
                            </div>
                            <div style="width: 386px;margin-left: 8px;" class="bodyinfo">
                                <table style="width: 100%; border-collapse: collapse;">
                                    <tbody>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                不动产单元号</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.BDCDYH + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                不动产权证号</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.BDCZH + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                小区名称</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.XQM + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                楼栋号</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.LDH + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                总层数</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            6</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                所在层</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + SZC + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                单元号</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.DYH + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                门户号</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + SZC + `` + params.ModelNum + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                房屋性质</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.FWXZ + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                户型</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.HX + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                权利人</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.QLR + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                权属状态</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.QSZT + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                联系电话</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.LXDH + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                权力类型</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.QLLX + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                登记类型</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.DJLX + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                建筑面积</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.JZMJ + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                登记机构</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            ` + params.DJJG + `</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td
                                                style="width: 30%; color: white; border: 1px solid #37579a; padding-left: 15px;font-size: 14px;">
                                                备注</td>
                                            <td
                                                style="width: 70%;color: white;border: 1px solid #37579a;padding-left: 20px;font-size: 14px;">
                                            无</td>
                                        </tr>
                                        <tr style="height: 36px;">
                                            <td colspan="2" style="color: white; border: 1px solid #37579a; padding: 0 40px;font-size: 14px;">
                                                <div style="width: 100%; color: white;display: flex;justify-content: center;align-items: center;">
                                                    <img attrVal = "HX" class="HIcon" title="户型图" style="cursor: pointer;margin-right: 30px;" src="/MapServer/Portal/img/analysis/dp.png">
                                                    <img attrVal = "QJ" class="HIcon" title="全景图" style="cursor: pointer;margin-right: 30px;" src="/MapServer/Portal/img/analysis/dp.png">
                                                    <img attrVal = "JG" class="HIcon" title="结构图" style="cursor: pointer;margin-right: 30px;" src="/MapServer/Portal/img/analysis/dp.png">
                                                    <img attrVal = "VIDEO" class="HIcon" title="视频" style="cursor: pointer;margin-right: 30px;" src="/MapServer/Portal/img/analysis/dp.png">
                                                </div>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>`
                formDIV.innerHTML = html;
                realEstatePathInfoDOM = formDIV
                document.body.appendChild(realEstatePathInfoDOM);
                $(".HIcon").click(function (e) {
                    var attrVal = $(e.currentTarget).attr("attrVal")
                    realEstateLayerInfoDom && realEstateLayerInfoDom.remove();
                    realEstateLayerInfoDom = document.createElement("div");
                    realEstateLayerInfoDom.className = "realEstateLayerInfoDOM";
                    var html = `
                                    <div class="fly_icon_div">
                                        <img class="fly_close_icon" id="closeRealEstateLayerInfoDom" style="" title="关闭" src="/MapServer/Portal/js/fun/fly/images/circle_close.png">
                                    </div>`
                    realEstateLayerInfoDom.style.padding = "25px"
                    switch (attrVal) {
                        case "HX":
                            html += `<img src="/MapServer/Portal/img/analysis/户型图.jpg" style="width:100%;height:100%;border-radius: 8px;">`;
                            break;
                        case "QJ":
                            html += `<img src="/MapServer/Portal/img/analysis/户型图.jpg" style="width:100%;height:100%;border-radius: 8px;">`;

                            break;
                        case "JG":
                            html += `<img src="/MapServer/Portal/img/analysis/户型图.jpg" style="width:100%;height:100%;border-radius: 8px;">`;

                            break;
                        case "VIDEO":
                            html += `<video id="HVideo" controls autoplay loop style="width: 100%;height: 100%;">
                                    <source src="/MapServer/Portal/img/analysis/testVideo.mp4" type="video/mp4">
                                    </video>`;
                            break;
                        default:
                            break;
                    }
                    realEstateLayerInfoDom.innerHTML = html;
                    document.body.appendChild(realEstateLayerInfoDom);
                    $("#closeRealEstateLayerInfoDom").click(function (e) {
                        realEstateLayerInfoDom.remove();
                    });
                })
                break;
            default:
                break;
        }
    } else {
        layer.msg("参数传递错误！")
    }



    $("#closerealEstatePathInfoDOM").click(function (e) {
        realEstatePathInfoDOM.remove();
    })



}

/**
 * 关闭不动产查询功能
 */
function closeSelectModelServer() {
    viewer.screenSpaceEventHandler.setInputAction(function onLeftClick(movement) {
        visible = false;
        EntityLayer.entities.removeAll();
        realEstatePathInfoDOM && realEstatePathInfoDOM.remove();
        cesium.layer3DList[modelID].show = false;
        cesium.layer3DList[modelID]["GLOBALVISIBLE"] = false;
        viewer.cesiumWidget.screenSpaceEventHandler.removeInputAction(Cesium.ScreenSpaceEventType.LEFT_CLICK);

    }, Cesium.ScreenSpaceEventType.RIGHT_CLICK);

}




