import {checkLayerTransparent} from "@/utils/map/layerHelper"
//OpenStreetMapImageryProvider
export function StreetMapService(layerInfo) {
    var StreetMapService = new Object;
    StreetMapService.id = layerInfo.hasOwnProperty("GUID") ? layerInfo.GUID : "";
    StreetMapService.url = layerInfo.hasOwnProperty("URL") ? layerInfo.URL : "";
    StreetMapService.name = layerInfo.hasOwnProperty("NAME") ? layerInfo.NAME : "";
    StreetMapService.servertype = layerInfo.hasOwnProperty("SERVERTYPE") ? layerInfo.SERVERTYPE : "tile";
    StreetMapService.showLayer = (layerInfo.hasOwnProperty("PARAMETERS") && layerInfo.PARAMETERS != "") ? layerInfo.PARAMETERS : layerInfo.ID;
    StreetMapService.transparent = (layerInfo.hasOwnProperty("transparent") && layerInfo.transparent != "") ? layerInfo.transparent : "";
    StreetMapService.layerindex = (layerInfo.hasOwnProperty("layerindex") && layerInfo.layerindex != "") ? layerInfo.layerindex : "";
    
    StreetMapService.CreateLayer = function (viewer) {
        var id = this.id;
        var url = this.url;
        var name = this.name;
        var servertype = this.servertype;
        var showLayer = this.showLayer == "" ? "" : "show:" + this.showLayer;
        var proxyUrl = "";
        var layers = viewer.imageryLayers;
        // var layerindex = layers._layers.length;

        var layerindex = (this.layerindex != "" && this.layerindex > layers._layers.length) ? layers._layers.length : layerindex;
        var transparent = this.transparent;

        var thisLayer = layers.addImageryProvider(new Cesium.OpenStreetMapImageryProvider({
            url: url
        }),layerindex);
        checkLayerTransparent(thisLayer, id , transparent);
        return thisLayer;
    }
    return StreetMapService;
}