﻿import {checkLayerTransparent} from "@/utils/map/layerHelper"
//Template服务
import * as Cesium from "cesium";
export function TemplateMapService(layerInfo) {
    var TemplateMapServer = new Object;
    TemplateMapServer.id = layerInfo.hasOwnProperty("GUID") ? layerInfo.GUID : "";
    TemplateMapServer.url = layerInfo.hasOwnProperty("URL") ? layerInfo.URL : "";
    TemplateMapServer.name = layerInfo.hasOwnProperty("NAME") ? layerInfo.NAME : "";
    TemplateMapServer.servertype = layerInfo.hasOwnProperty("SERVERTYPE") ? layerInfo.SERVERTYPE : "";
    TemplateMapServer.showLayer = (layerInfo.hasOwnProperty("PARAMETERS") && layerInfo.PARAMETERS != "") ? layerInfo.PARAMETERS : layerInfo.ID;
    TemplateMapServer.maximumLevel = layerInfo.hasOwnProperty("maximumLevel") ? layerInfo.maximumLevel : undefined;
    TemplateMapServer.minimumLevel = layerInfo.hasOwnProperty("minimumLevel") ? layerInfo.minimumLevel : 0;
    TemplateMapServer.transparent = (layerInfo.hasOwnProperty("transparent") && layerInfo.transparent != "") ? layerInfo.transparent : "";
    TemplateMapServer.layerindex = (layerInfo.hasOwnProperty("layerindex") && layerInfo.layerindex != "") ? layerInfo.layerindex : "";
    
    TemplateMapServer.CreateLayer = function (viewer) {
        var id = this.id;
        var url = this.url;
        var name = this.name;
        var servertype = this.servertype;
        var proxyUrl = "";
        var layers = viewer.imageryLayers;
        // var layerindex = layers._layers.length;

        var layerindex = (this.layerindex != "" && this.layerindex > layers._layers.length) ? layers._layers.length : layerindex;
        var transparent = this.transparent;
        var thisLayer = layers.addImageryProvider(new Cesium.UrlTemplateImageryProvider({
            url: url, //服务地址
            maximumLevel: this.maximumLevel,
            minimumLevel: this.minimumLevel,
            //minificationFilter: Cesium.TextyreMinificationFiler.NEAREST,
            magnificationFilter: Cesium.TextureMagnificationFilter.NEAREST,
            minificationFilter: Cesium.TextureMagnificationFilter.NEAREST_MIPMAP_NEAREST
        }), layerindex);
        checkLayerTransparent(thisLayer, id, transparent);
        return thisLayer;
    }
    return TemplateMapServer;
}