﻿/*
 * @Descripttion: 
 * @version: 
 * @Author: 牛夏蕊
 * @Date: 2022-07-29 11:23:34
 * @LastEditors: 牛夏蕊
 * @LastEditTime: 2022-07-29 16:19:08
 */
//地形服务
import * as Cesium from "cesium";
export function TerrainService(layerInfo) {
    var TerrainService = new Object;
    TerrainService.id = layerInfo.hasOwnProperty("GUID") ? layerInfo.GUID : "";
    TerrainService.url = layerInfo.hasOwnProperty("URL") ? layerInfo.URL.replace("http://http://", "http://") : "";
    TerrainService.name = layerInfo.hasOwnProperty("NAME") ? layerInfo.NAME : "";
    TerrainService.servertype = layerInfo.hasOwnProperty("SERVERTYPE") ? layerInfo.SERVERTYPE : "";
    TerrainService.token = layerInfo.hasOwnProperty("TOKEN") ? layerInfo.TOKEN : "";
    TerrainService.CreateLayer = function(viewer) {
        var url = this.url;
        var id = this.id;
        var status = this.status;
        var token = this.token;
        var thisLayer = null;
        if (url != "") { //url不为空则加载指定地形服务
            thisLayer = new Cesium.CesiumTerrainProvider({
                url: url,
                id: id,
                ellipsoid: viewer.scene.globe.ellipsoid,
                isSct: false,
                //heightmapTerrainQuality: 256
            });
        } else if (token != "") { //url为空，token不为空，加载在线服务
            Cesium.Ion.defaultAccessToken = token;
            thisLayer = new Cesium.CesiumTerrainProvider({
                url: Cesium.IonResource.fromAssetId(1),
                id: id
            })
        }else{
            thisLayer = Cesium.createWorldTerrain({
                requestWaterMask: false,
                requestVertexNormals: false
            });
        }
        viewer.scene.terrainProvider = thisLayer;
        viewer.Terrain = true;
        viewer.scene.globe.enableLighting = false;
        return thisLayer;
    }
    return TerrainService;
}