/*
 * @Descripttion: 
 * @version: 
 * @Author: 牛夏蕊
 * @Date: 2022-07-28 17:40:37
 * @LastEditors: 牛夏蕊
 * @LastEditTime: 2022-07-28 17:46:11
 */
import {checkLayerTransparent} from "@/utils/map/layerHelper"
//OpenStreetMapImageryProvider
import * as Cesium from "cesium";
export function TileTiandituService(layerInfo) {
    var TileTiandituService = new Object;
    TileTiandituService.id = layerInfo.hasOwnProperty("GUID") ? layerInfo.GUID : "";
    TileTiandituService.url = layerInfo.hasOwnProperty("URL") ? layerInfo.URL : "";
    TileTiandituService.name = layerInfo.hasOwnProperty("NAME") ? layerInfo.NAME : "";
    TileTiandituService.servertype = layerInfo.hasOwnProperty("SERVERTYPE") ? layerInfo.SERVERTYPE : "tile";
    TileTiandituService.showLayer = (layerInfo.hasOwnProperty("PARAMETERS") && layerInfo.PARAMETERS != "") ? layerInfo.PARAMETERS : layerInfo.ID;
    TileTiandituService.transparent = (layerInfo.hasOwnProperty("transparent") && layerInfo.transparent != "") ? layerInfo.transparent : "";
    TileTiandituService.layerindex = (layerInfo.hasOwnProperty("layerindex") && layerInfo.layerindex != "") ? layerInfo.layerindex : "";
    
    TileTiandituService.CreateLayer = function (viewer) {
        var id = this.id;
        var url = this.url;
        var name = this.name;
        var servertype = this.servertype;
        var showLayer = this.showLayer == "" ? "" : "show:" + this.showLayer;
        var proxyUrl = "";
        var layers = viewer.imageryLayers;
        // var layerindex = layers._layers.length;

        var layerindex = (this.layerindex != "" && this.layerindex > layers._layers.length) ? layers._layers.length : layerindex;
        var transparent = this.transparent;
        var subdomains = ['0', '1', '2', '3', '4', '5', '6', '7'];

        var thisLayer = layers.addImageryProvider(new Cesium.WebMapTileServiceImageryProvider({   
            //影像注记
            url: url + "&tk=" +  m_MapConfigLayers.tiandituTk,
            subdomains: subdomains,
            // layer: layerid,
            style: "default",
            format: "image/jpeg",
            tileMatrixSetID: "GoogleMapsCompatible",
            show: true
        }),layerindex);
        checkLayerTransparent(thisLayer, id , transparent);
        return thisLayer;
    }
    return TileTiandituService;
}