import { Fill, Stroke, Circle, Style, Text } from 'ol/style';
import myMap from "@/utils/map.js";
const mapConfig = (function() {
    var mapConfigs = {
        /*辅助选址*/
        "fzxz_layer": {
            title: 'DLMC',
            attrs: [
                { sxbm: "用地代码", sxmc: "DLBM" },
                { sxbm: "用地名称", sxmc: "DLMC" },
                { sxbm: "图斑面积", sxmc: "TBMJ", callback: (val) => { return val.toFixed(0) + "" } },
                {
                    sxbm: "选址方案",
                    sxmc: "YXFA",
                    callback: (val) => {
                        if (val == 0) return '未选';
                        else return '已选'
                    }
                }
            ],
            popupInfo: true,
        },
        /*区县面*/
        "county": {
            name: "	county",
            title: "区县面",
            type: "polygon",
            colors: {
                '150602': "#ffff66",
                '150603': "#ffff66",
                '150621': "#ffff66",
                '150622': "#ffff66",
                '150623': "#ffff66",
                '150624': "#ffff66",
                '150625': "#ffff66",
                '150626': "#ffff66",
                '150627': "#ffff66"
            },
            style: function(feature) {
                var $this = mapConfigs["county"];
                var color = $this.colors[feature.get('XZQDM')];
                var _val = feature.get("XZQMC");
                console.log(_val)
                return new Style({
                    stroke: new Stroke({
                        color: color,
                        width: 2,
                        lineCap: 'square',
                        lineDash: [1, 2, 3, 4, 5],
                    }),
                    fill: new Fill({
                        color: color
                    }),
                    text: new Text({
                        text: _val,
                        textAlign: "left",
                        font: "13px Arial",
                        fill: new Fill({ color: "#aa3300" }),
                        stroke: new Stroke({ color: "#FFFFFF", width: 1 })
                    }),
                    zIndex: 5
                });
            },
        },


        /*规划图斑*/
        "2090020620": {
            name: "GHYDYH",
            title: "规划图斑",
            type: "polygon",
            colors: [],
            style: function(feature) {
                var $this = mapConfig["2090020620"];
                var colors = [{ "bsm": "01", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "01", "tlmc": "耕地", "tllx": "color", "tlys": "rgb(245,248,220)" }, { "bsm": "0101", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0101", "tlmc": "水田", "tllx": "color", "tlys": "rgb(245248220)" }, { "bsm": "0102", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0102", "tlmc": "水浇地", "tllx": "color", "tlys": "rgb(245,248,220)" }, { "bsm": "0103", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0103", "tlmc": "旱地", "tllx": "color", "tlys": "rgb(245,248,220)" }, { "bsm": "02", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "02", "tlmc": "园地", "tllx": "color", "tlys": "rgb(191,233,170)" }, { "bsm": "0201", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0201", "tlmc": "果园", "tllx": "color", "tlys": "rgb(191,233,170)" }, { "bsm": "0202", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0202", "tlmc": "茶园", "tllx": "color", "tlys": "rgb(191,233,170)" }, { "bsm": "0203", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0203", "tlmc": "橡胶园", "tllx": "color", "tlys": "rgb(191,233,170)" }, { "bsm": "0204", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0204", "tlmc": "其他园地", "tllx": "color", "tlys": "rgb(191,233,170)" }, { "bsm": "03", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "03", "tlmc": "林地", "tllx": "color", "tlys": "rgb(104,177,103)" }, { "bsm": "0301", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0301", "tlmc": "乔木林地", "tllx": "color", "tlys": "rgb(104,177,103)" }, { "bsm": "0302", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0302", "tlmc": "竹林地", "tllx": "color", "tlys": "rgb(104,177,103)" }, { "bsm": "0303", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0303", "tlmc": "灌木林地", "tllx": "color", "tlys": "rgb(104,177,103)" }, { "bsm": "0304", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0304", "tlmc": "其他林地", "tllx": "color", "tlys": "rgb(104,177,103)" }, { "bsm": "04", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "04", "tlmc": "草地", "tllx": "color", "tlys": "rgb(205,245,122)" }, { "bsm": "0401", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0401", "tlmc": "天然牧草地", "tllx": "color", "tlys": "rgb(205,245,122)" }, { "bsm": "0402", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0402", "tlmc": "人工牧草地", "tllx": "color", "tlys": "rgb(205,245,122)" }, { "bsm": "0403", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0403", "tlmc": "其他草地", "tllx": "color", "tlys": "rgb(205,245,122)" }, { "bsm": "05", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "05", "tlmc": "湿地", "tllx": "color", "tlys": "rgb(101,205,170)" }, { "bsm": "0501", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0501", "tlmc": "森林沼泽", "tllx": "color", "tlys": "rgb(101,205,170)" }, { "bsm": "0502", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0502", "tlmc": "灌丛沼泽", "tllx": "color", "tlys": "rgb(101,205,170)" }, { "bsm": "0503", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0503", "tlmc": "沼泽草地", "tllx": "color", "tlys": "rgb(101,205,170)" }, { "bsm": "0504", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0504", "tlmc": "其他沼泽地", "tllx": "color", "tlys": "rgb(101,205,170)" }, { "bsm": "0505", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0505", "tlmc": "沿海滩涂", "tllx": "color", "tlys": "rgb(101,205,170)" }, { "bsm": "0506", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0506", "tlmc": "内陆滩涂", "tllx": "color", "tlys": "rgb(101,205,170)" }, { "bsm": "0507", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0507", "tlmc": "红树林地", "tllx": "color", "tlys": "rgb(101,205,170)" }, { "bsm": "06", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "06", "tlmc": "农业设施建设用地", "tllx": "color", "tlys": "rgb(216,215,159)" }, { "bsm": "0601", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0601", "tlmc": "乡村道路用地", "tllx": "color", "tlys": "rgb(216,215,159)" }, { "bsm": "060101", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "060101", "tlmc": "村道用地", "tllx": "color", "tlys": "rgb(216,215,159)" }, { "bsm": "060102", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "060102", "tlmc": "村庄内部道路用地", "tllx": "color", "tlys": "rgb(216,215,159)" }, { "bsm": "0602", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0602", "tlmc": "种植设施建设用地", "tllx": "color", "tlys": "rgb(216,215,159)" }, { "bsm": "0603", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0603", "tlmc": "畜禽养殖设施建设用地", "tllx": "color", "tlys": "rgb(216,215,159)" }, { "bsm": "0604", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0604", "tlmc": "水产养殖设施建设用地", "tllx": "color", "tlys": "rgb(216,215,159)" }, { "bsm": "07", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "07", "tlmc": "居住用地", "tllx": "color", "tlys": "rgb(255,255,45)" }, { "bsm": "0701", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0701", "tlmc": "城镇住宅用地", "tllx": "color", "tlys": "rgb(255,255,45)" }, { "bsm": "070101", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "070101", "tlmc": "一类城镇住宅用地", "tllx": "color", "tlys": "rgb(255,255,45)" }, { "bsm": "070102", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "070102", "tlmc": "二类城镇住宅用地", "tllx": "color", "tlys": "rgb(255,255,45)" }, { "bsm": "070103", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "070103", "tlmc": "三类城镇住宅用地", "tllx": "color", "tlys": "rgb(255,255,45)" }, { "bsm": "0702", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0702", "tlmc": "城镇社区服务设施用地", "tllx": "color", "tlys": "rgb(255,255,45)" }, { "bsm": "0703", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0703", "tlmc": "农村宅基地", "tllx": "color", "tlys": "rgb(255,211,128)" }, { "bsm": "070301", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "070301", "tlmc": "一类农村宅基地", "tllx": "color", "tlys": "rgb(255,211,128)" }, { "bsm": "070302", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "070302", "tlmc": "二类农村宅基地", "tllx": "color", "tlys": "rgb(255,211,128)" }, { "bsm": "0704", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0704", "tlmc": "农村社区服务设施用地", "tllx": "color", "tlys": "rgb(255,255,45)" }, { "bsm": "08", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "08", "tlmc": "公共管理与公共服务用地", "tllx": "color", "tlys": "rgb(255,0,255)" }, { "bsm": "0801", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0801", "tlmc": "机关团体用地", "tllx": "color", "tlys": "rgb(225,0,255)" }, { "bsm": "0802", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0802", "tlmc": "科研用地", "tllx": "color", "tlys": "rgb(230,0,92)" }, { "bsm": "080301", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080301", "tlmc": "图书与展览用地", "tllx": "color", "tlys": "rgb(255,127,0)" }, { "bsm": "080302", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080302", "tlmc": "文化活动用地", "tllx": "color", "tlys": "rgb(255,127,0)" }, { "bsm": "0804", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0804", "tlmc": "教育用地", "tllx": "color", "tlys": "rgb(255,133,201)" }, { "bsm": "080401", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080401", "tlmc": "高等教育用地", "tllx": "color", "tlys": "rgb(255,133,201)" }, { "bsm": "080402", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080402", "tlmc": "中等职业教育用地", "tllx": "color", "tlys": "rgb(255,133,201)" }, { "bsm": "080403", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080403", "tlmc": "中小学用地", "tllx": "color", "tlys": "rgb(255,133,201)" }, { "bsm": "080404", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080404", "tlmc": "幼儿园用地", "tllx": "color", "tlys": "rgb(255,133,201)" }, { "bsm": "0805", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0805", "tlmc": "体育用地", "tllx": "color", "tlys": "rgb(0,165,124)" }, { "bsm": "080501", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080501", "tlmc": "体育场馆用地", "tllx": "color", "tlys": "rgb(0,165,124)" }, { "bsm": "080502", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080502", "tlmc": "体育训练用地", "tllx": "color", "tlys": "rgb(0,165,124)" }, { "bsm": "0806", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0806", "tlmc": "医疗卫生用地", "tllx": "color", "tlys": "rgb(255,127,126)" }, { "bsm": "080601", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080601", "tlmc": "医院用地", "tllx": "color", "tlys": "rgb(255,127,126)" }, { "bsm": "080602", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080602", "tlmc": "基层医疗卫生设施用地", "tllx": "color", "tlys": "rgb(255,127,126)" }, { "bsm": "080603", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080603", "tlmc": "公共卫生用地", "tllx": "color", "tlys": "rgb(255,127,126)" }, { "bsm": "0807", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0807", "tlmc": "社会福利用地", "tllx": "color", "tlys": "rgb(255,159,127)" }, { "bsm": "080701", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080701", "tlmc": "老年人社会福利用地", "tllx": "color", "tlys": "rgb(255,159,127)" }, { "bsm": "080702", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080702", "tlmc": "儿童社会福利用地", "tllx": "color", "tlys": "rgb(255,159,127)" }, { "bsm": "080703", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080703", "tlmc": "残疾人社会福利用地", "tllx": "color", "tlys": "rgb(255,159,127)" }, { "bsm": "080704", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "080704", "tlmc": "其他社会福利用地", "tllx": "color", "tlys": "rgb(255,159,127)" }, { "bsm": "09", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "09", "tlmc": "商业服务业用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "0901", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0901", "tlmc": "商业用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "090101", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "090101", "tlmc": "零售商业用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "090102", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "090102", "tlmc": "批发市场用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "090103", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "090103", "tlmc": "餐饮用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "090104", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "090104", "tlmc": "旅馆用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "090105", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "090105", "tlmc": "公用设施营业网点用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "0902", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0902", "tlmc": "商务金融用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "0903", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0903", "tlmc": "商务金融用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "090301", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "090301", "tlmc": "娱乐用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "090302", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "090302", "tlmc": "康体用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "0904", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0904", "tlmc": "其他商业服务业用地", "tllx": "color", "tlys": "rgb(255,0,0)" }, { "bsm": "10", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "10", "tlmc": "工矿用地", "tllx": "color", "tlys": "rgb(187,150,116)" }, { "bsm": "1001", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1001", "tlmc": "工业用地", "tllx": "color", "tlys": "rgb(187,150,116)" }, { "bsm": "100101", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "100101", "tlmc": "一类工业用地", "tllx": "color", "tlys": "rgb(187,150,116)" }, { "bsm": "100102", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "100102", "tlmc": "二类工业用地", "tllx": "color", "tlys": "rgb(187,150,116)" }, { "bsm": "100103", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "100103", "tlmc": "三类工业用地", "tllx": "color", "tlys": "rgb(187,150,116)" }, { "bsm": "1002", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1002", "tlmc": "采矿用地", "tllx": "color", "tlys": "rgb(158,108,84)" }, { "bsm": "1003", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1003", "tlmc": "盐田", "tllx": "color", "tlys": "rgb(0,0,255)" }, { "bsm": "11", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "11", "tlmc": "仓储用地", "tllx": "color", "tlys": "rgb(135,98,211)" }, { "bsm": "1101", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1101", "tlmc": "物流仓储用地", "tllx": "color", "tlys": "rgb(135,98,211)" }, { "bsm": "110101", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "110101", "tlmc": "一类物流仓储用地", "tllx": "color", "tlys": "rgb(135,98,211)" }, { "bsm": "110102", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "110102", "tlmc": "二类物流仓储用地", "tllx": "color", "tlys": "rgb(135,98,211)" }, { "bsm": "110103", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "110103", "tlmc": "三类物流仓储用地", "tllx": "color", "tlys": "rgb(135,98,211)" }, { "bsm": "1102", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1102", "tlmc": "储备库用地", "tllx": "color", "tlys": "rgb(153,153,255)" }, { "bsm": "1201", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1201", "tlmc": "铁路用地", "tllx": "color", "tlys": "rgb(183,183,183)" }, { "bsm": "1202", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1202", "tlmc": "公路用地", "tllx": "color", "tlys": "rgb(173,173,173)" }, { "bsm": "1203", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1203", "tlmc": "机场用地", "tllx": "color", "tlys": "rgb(183,183,183)" }, { "bsm": "1204", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1204", "tlmc": "港口码头用地", "tllx": "color", "tlys": "rgb(183,183,183)" }, { "bsm": "1205", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1205", "tlmc": "管道运输用地", "tllx": "color", "tlys": "rgb(153,153,153)" }, { "bsm": "1206", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1206", "tlmc": "城市轨道交通用地", "tllx": "color", "tlys": "rgb(183,183,183)" }, { "bsm": "1207", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1207", "tlmc": "城镇道路用地", "tllx": "color", "tlys": "rgb(163,163,163)" }, { "bsm": "1208", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1208", "tlmc": "交通场站用地", "tllx": "color", "tlys": "rgb(183,183,183)" }, { "bsm": "120801", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "120801", "tlmc": "对外交通场站用地", "tllx": "color", "tlys": "rgb(183,183,183)" }, { "bsm": "120802", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "120802", "tlmc": "公共交通场站用地", "tllx": "color", "tlys": "rgb(183,183,183)" }, { "bsm": "120803", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "120803", "tlmc": "社会停车场用地", "tllx": "color", "tlys": "rgb(183,183,183)" }, { "bsm": "1209", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1209", "tlmc": "其他交通设施用地", "tllx": "color", "tlys": "rgb(183,183,183)" }, { "bsm": "13", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "13", "tlmc": "公用设施用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1301", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1301", "tlmc": "供水用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1302", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1302", "tlmc": "排水用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1303", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1303", "tlmc": "供电用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1304", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1304", "tlmc": "供燃气用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1305", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1305", "tlmc": "供热用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1306", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1306", "tlmc": "通信用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1307", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1307", "tlmc": "邮政用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1308", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1308", "tlmc": "广播电视设施用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1309", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1309", "tlmc": "环卫用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1310", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1310", "tlmc": "消防用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1311", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1311", "tlmc": "干渠", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1312", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1312", "tlmc": "水工设施用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "1313", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1313", "tlmc": "其他公用设施用地", "tllx": "color", "tlys": "rgb(0,99,128)" }, { "bsm": "14", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "14", "tlmc": "绿地与开敞空间用地", "tllx": "color", "tlys": "rgb(0,255,0)" }, { "bsm": "1401", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1401", "tlmc": "公园绿地", "tllx": "color", "tlys": "rgb(0,255,0)" }, { "bsm": "1402", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1402", "tlmc": "防护绿地", "tllx": "color", "tlys": "rgb(20,141,74)" }, { "bsm": "1403", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1403", "tlmc": "广场用地", "tllx": "color", "tlys": "rgb(172,255,207)" }, { "bsm": "15", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "15", "tlmc": "特殊用地", "tllx": "color", "tlys": "rgb(133,145,86)" }, { "bsm": "1501", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1501", "tlmc": "军事设施用地", "tllx": "color", "tlys": "rgb(133,145,86)" }, { "bsm": "1502", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1502", "tlmc": "使领馆用地", "tllx": "color", "tlys": "rgb(133,145,86)" }, { "bsm": "1503", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1503", "tlmc": "宗教用地", "tllx": "color", "tlys": "rgb(133,145,86)" }, { "bsm": "1504", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1504", "tlmc": "文物古迹用地", "tllx": "color", "tlys": "rgb(133,145,86)" }, { "bsm": "1505", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1505", "tlmc": "监教场所用地", "tllx": "color", "tlys": "rgb(133,145,86)" }, { "bsm": "1506", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1506", "tlmc": "殡葬用地", "tllx": "color", "tlys": "rgb(133,145,86)" }, { "bsm": "1507", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1507", "tlmc": "其他特殊用地", "tllx": "color", "tlys": "rgb(133,145,86)" }, { "bsm": "16", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "16", "tlmc": "留白用地", "tllx": "color", "tlys": "rgb(255,255,255)" }, { "bsm": "17", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "17", "tlmc": "陆地水域", "tllx": "color", "tlys": "rgb(51,142,192)" }, { "bsm": "1701", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1701", "tlmc": "河流水面", "tllx": "color", "tlys": "rgb(51,142,192)" }, { "bsm": "1702", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1702", "tlmc": "湖泊水面", "tllx": "color", "tlys": "rgb(51,142,192)" }, { "bsm": "1703", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1703", "tlmc": "水库水面", "tllx": "color", "tlys": "rgb(51,142,192)" }, { "bsm": "1704", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1704", "tlmc": "坑塘水面", "tllx": "color", "tlys": "rgb(51,142,192)" }, { "bsm": "1705", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1705", "tlmc": "沟渠", "tllx": "color", "tlys": "rgb(51,142,192)" }, { "bsm": "1706", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1706", "tlmc": "冰川及常年积雪", "tllx": "color", "tlys": "rgb(51,142,192)" }, { "bsm": "18", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "18", "tlmc": "渔业用海", "tllx": "color", "tlys": "rgb(148,213,235)" }, { "bsm": "1801", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1801", "tlmc": "渔业基础设施用海", "tllx": "color", "tlys": "rgb(148,213,235)" }, { "bsm": "1802", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1802", "tlmc": "增养殖用海", "tllx": "color", "tlys": "rgb(148,213,235)" }, { "bsm": "1803", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1803", "tlmc": "捕捞海域", "tllx": "color", "tlys": "rgb(148,213,235)" }, { "bsm": "19", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "19", "tlmc": "工矿通信用海", "tllx": "color", "tlys": "rgb(86,166,211)" }, { "bsm": "1901", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1901", "tlmc": "工业用海", "tllx": "color", "tlys": "rgb(86,166,211)" }, { "bsm": "1902", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1902", "tlmc": "盐田用海", "tllx": "color", "tlys": "rgb(86,166,211)" }, { "bsm": "1903", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1903", "tlmc": "固体矿产用海", "tllx": "color", "tlys": "rgb(86,166,211)" }, { "bsm": "1904", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1904", "tlmc": "油气用海", "tllx": "color", "tlys": "rgb(86,166,211)" }, { "bsm": "1905", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1905", "tlmc": "可再生能源用海", "tllx": "color", "tlys": "rgb(86,166,211)" }, { "bsm": "1906", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "1906", "tlmc": "海底电缆管道用海", "tllx": "color", "tlys": "rgb(86,166,211)" }, { "bsm": "20", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "20", "tlmc": "交通运输用海", "tllx": "color", "tlys": "rgb(108,139,209)" }, { "bsm": "2001", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2001", "tlmc": "港口用海", "tllx": "color", "tlys": "rgb(108,139,209)" }, { "bsm": "2002", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2002", "tlmc": "航运用海", "tllx": "color", "tlys": "rgb(108,139,209)" }, { "bsm": "2003", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2003", "tlmc": "路桥隧道用海", "tllx": "color", "tlys": "rgb(108,139,209)" }, { "bsm": "21", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "21", "tlmc": "游憩用海", "tllx": "color", "tlys": "rgb(26,170,230)" }, { "bsm": "2101", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2101", "tlmc": "风景旅游用海", "tllx": "color", "tlys": "rgb(26,170,230)" }, { "bsm": "2102", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2102", "tlmc": "文体休闲娱乐用海", "tllx": "color", "tlys": "rgb(26,170,230)" }, { "bsm": "22", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "22", "tlmc": "特殊用海", "tllx": "color", "tlys": "rgb(131,188,214)" }, { "bsm": "2201", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2201", "tlmc": "军事用海", "tllx": "color", "tlys": "rgb(131,188,214)" }, { "bsm": "2202", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2202", "tlmc": "其他特殊用海", "tllx": "color", "tlys": "rgb(131,188,214)" }, { "bsm": "23", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "23", "tlmc": "其他土地", "tllx": "color", "tlys": "rgb(238,238,238)" }, { "bsm": "2301", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2301", "tlmc": "空闲地", "tllx": "color", "tlys": "rgb(238,238,238)" }, { "bsm": "2302", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2302", "tlmc": "田坎", "tllx": "color", "tlys": "rgb(238,238,238)" }, { "bsm": "2303", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2303", "tlmc": "田间道", "tllx": "color", "tlys": "rgb(238,238,238)" }, { "bsm": "2304", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2304", "tlmc": "盐碱地", "tllx": "color", "tlys": "rgb(238,238,238)" }, { "bsm": "2305", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2305", "tlmc": "沙地", "tllx": "color", "tlys": "rgb(238,238,238)" }, { "bsm": "2306", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2306", "tlmc": "裸土地", "tllx": "color", "tlys": "rgb(238,238,238)" }, { "bsm": "2307", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "2307", "tlmc": "裸岩石砾地", "tllx": "color", "tlys": "rgb(238,238,238)" }, { "bsm": "24", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "24", "tlmc": "其他海域", "tllx": "color", "tlys": "rgb(214,234,243)" }, { "bsm": "0803", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "0803", "tlmc": "文化用地", "tllx": "color", "tlys": "rgb(255,127,0)" }, { "bsm": "12", "zybsm": "2090020620", "zymc": "规划用地用海", "tldm": "12", "tlmc": "交通运输用地", "tllx": "color", "tlys": "rgb(183,183,183)" }];

                console.log($this, colors)
                console.log(feature.get('YDYHFLDM'))
                var item = colors.filter(t => t.tldm == feature.get('YDYHFLDM'))[0];
                console.log(item)
                var color = item["tlys"];
                return new Style({
                    stroke: new Stroke({
                        color: color,
                        width: 1
                    }),
                    fill: new Fill({
                        color: color
                    }),
                    text: new Text({
                        text: feature.get('YDYHFLDM'),
                        textAlign: "left",
                        font: "13px Arial",
                        fill: new Fill({ color: "#000" }),
                        stroke: new Stroke({ color: "#FFFFFF", width: 1 })
                    }),
                    zIndex: 5
                });
            },
            popupInfo: function(feature, type, point, maptype) {
                console.log(feature)
                var popup = {
                    title: `${feature.get('YDYHFLMC')}(${feature.get('YDYHFLDM')})`,
                    feature: feature,
                    position: point,
                    type: maptype,
                    attrs: {
                        YSDM: { name: "要素代码", callback: function(val) { return val || ""; } },
                        YDYHFLDM: { name: "用地用海分类代码", callback: function(val) { return val || ""; } },
                        YDYHFLMC: { name: "用地用海分类名称", callback: function(val) { return val || ""; } },
                        MJ: { name: "面积", callback: function(val) { return val.toFixed(0) + "m²"; } },
                        XZQDM: { name: "行政区代码", callback: function(val) { return val || ""; } },
                        XZQMC: { name: "行政区名称", callback: function(val) { return val || ""; } },
                        GHZT: {
                            name: "规划状态",
                            callback: function(val) {
                                switch (val) {
                                    case "10":
                                        return "现状";
                                    case "20":
                                        return "规划";
                                    case "30":
                                        return "在（待）建";
                                    case "90":
                                        return "其他";
                                }
                                return val;
                            }
                        },
                    },
                }
                console.log(popup)
                myMap.popupInfo(popup);
            }
        },

    }
    return mapConfigs;
})();
export default mapConfig;