/*
 * @Descripttion: 
 * @version: 
 * @Author: 牛夏蕊
 * @Date: 2023-07-04 16:01:27
 * @LastEditors: 牛夏蕊
 * @LastEditTime: 2023-07-04 16:03:42
 */
import axios from 'axios'
import {
    ElMessage
} from 'element-plus'
import router from "@/router"
export const ACCESS_TOKEN = ''
// 创建 axios 实例
const request = axios.create({
    // API 请求的默认前缀
    //baseURL: process.env.APP_API_BASE_URL,
    timeout: 0.5 * 60 * 60 * 1000 // 请求超时时间 改成半小时，不然这个矢量渲染出不来
})
import {
    createApp
} from 'vue'
import App from '../App.vue'
const appConfjg = createApp(App).config.globalProperties
// 异常拦截处理器
const errorHandler = (error) => {

    // 错误提醒
    var msgInfo = '服务器错误';
    if (error && error.response) {
        switch (error.response.status) {
            case 400:
                msgInfo = '请求错误'
                break
            case 401:
                msgInfo = '未授权，请登录'
                break
            case 403:
                msgInfo = '拒绝访问'
                break
            case 404:
                msgInfo = `请求地址出错`
                break
            case 408:
                msgInfo = '请求超时'
                break
            case 500:
                msgInfo = '服务器内部错误'
                break
            case 501:
                msgInfo = '服务未实现'
                break
            case 502:
                msgInfo = '网关错误'
                break
            case 503:
                msgInfo = '服务不可用'
                break
            case 504:
                msgInfo = '网关超时'
                break
            case 505:
                msgInfo = 'HTTP版本不受支持'
                break
        }
        ElMessage.error(msgInfo)
        if (error.response.status == 401) {
            // localStorage.removeItem('eleToken')
            // 页面跳转 login
            router.push({
                name: 'Login'
            });
        }
    } else if (error.message == 'Network Error') {
        ElMessage.error('错误：网络错误')
    } else {
        ElMessage.error(`服务器内部错误`)
    }
    return Promise.reject(error)
}


// 请求拦截  设置统一header
request.interceptors.request.use(config => {
    config['cancelToken'] = new axios.CancelToken(function executor(cancel) {
        appConfjg.$httpRequestList && appConfjg.$httpRequestList.push(cancel) //存储cancle
    })
    return config
}, errorHandler)

// 响应拦截  401 token过期处理
request.interceptors.response.use(response => {
    // 强行中断请求要用到的，记录请求信息

    //把请求参数据返回回去
    if (response.data.hasOwnProperty('success') && !response.data.success) {
        ElMessage.error(response.data.message)
    }
    // response.data._params = response.config.params;
    return response.data;
}, error => {
    if (error.message === 'interrupt') {
        console.log('请求中断');
        return new Promise(() => { });
    }
    // Vue.$httpRequestList = [];
    return Promise.reject(error)
})

export default function ({
    method,
    url,
    data = null,
    headers = {
        'Content-Type': 'application/json;charset=UTF-8'
    }
}) {
    method = method.toLowerCase();
    if (method == 'post') {
        return request.post(url, data, headers)
    } else if (method == 'get') {
        return request.get(url, {
            params: data
        }, headers)
    } else if (method == 'delete') {
        return request.delete(url, {
            params: data
        }, headers)
    } else if (method == 'put') {
        return request.put(url, data, headers)
    } else {
        return false
    }
}